﻿/*
Gui 1 = LOGVIEW
Gui 2 = EXCLUDEHELP
Gui 3 = ABOUT
Gui 4 = OPTIONEN
Gui 5 = SPLASHSCREEN
Gui 6 = ABOUT
Gui 7 = MsgBox Ja StandBy Beenden
Gui 10 = Suchen
*/
#SingleInstance, Force
#NoEnv ; Recommended for performance and compatibility with future AutoHotkey releases.
SendMode, Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir, %A_ScriptDir%  ; Ensures a consistent starting directory.
ScriptName = RobocopyMonitor
ScriptVersion = 2.5
ScriptBuild = 0.2
ScriptDate = 20.11.13
HomePage = www.ophthalmostar.de
;SetControlDelay, 20 ; ControlSetText funktionierte nicht zuverlässig
WinDir := A_WinDir ; wird für #NoEnv benötigt
SplashColor = F7F9FA ; EFEFEF ; FFFFFF ; D9FFB5
TextColor = 000000 ; FFFFFF
SplitPath, A_ScriptFullPath,,,, ScriptNoExt
DetectHiddenWindows, On
; AHK_L - Code Page Identifiers: IBM850: OEM Multilingual Latin 1; Western European (DOS)
; IfEqual, A_IsUnicode, 1, FileEncoding, UTF-8 ; AHK_L
FileEncoding, CP850 ; for FileRead, FileReadLine, Loop Read, FileAppend, and FileOpen
Suspend, On
GoSub, INIFILE
GoSub, TRAYMENU
OnExit, SCRIPTEXIT
hCurs := DllCall("LoadCursor", "UInt", NULL, "Int", 32649, "UInt") ;IDC_HAND
;--- Fortsetzung erst wenn userinit.exe beendet ist, um USB-Sticks zu erkennen
Loop
  {
    Process, Exist, UserInit.exe
    IfEqual, ErrorLevel, 0, Break
    UserInit := True
    Sleep, 100
  }
If UserInit
  Sleep, 5000 ; zusätzliche Verzögerung
;------------------------------------------------------------------------------
GoSub, ROBOCOPYSTART
Return
;------------------------------------------------------------------------------
;                    end of auto-execute section
;------------------------------------------------------------------------------

TRAYMENU:
  Menu, Tray, NoStandard
  If (!A_IsCompiled)
      Menu, Tray, Icon, Shell32.dll, 175 ; 132
  Menu, Tray, Add, &Über, ABOUT
  Menu, Tray, Add, &Hilfe, HELPGUI
  Menu, Tray, Add
  Menu, Tray, Add, &Einstellungen, OPTIONEN
  Menu, Tray, Add, &Logdatei öffnen, LOGVIEW
  If (!A_IsCompiled)
    {
    Menu, AutoHotkey, Standard
    Menu, Tray, Add, AutoHotkey, :AutoHotkey
    }
  Menu, Tray, Add
  Menu, Tray, Add, &Fortsetzen, TRAYEVENT
  Menu, Tray, Add, &Beenden, ENDABFRAGE
  Menu, Tray, Tip, %ScriptName%`nLinke Maustaste: Logdatei öffnen`nRechte Maustaste: Menü anzeigen
  Menu, Tray, Default, &Logdatei öffnen
  Menu, Tray, Click, 1
Return

TRAYEVENT:
  If (A_IsSuspended)
      GoSub, ROBOCOPYSTART
  Else
      GoSub, PROCESSCLOSE
Return

TRAYRENAME:
  If (A_IsSuspended)
    {
      OldName = &Anhalten
      NewName = &Fortsetzen
   }
  Else
    {
      OldName = &Fortsetzen
      NewName = &Anhalten
    }
  Menu, Tray, Rename, %OldName%, %NewName%
Return

;------------------------------------------------------------------------------

INIFILE:
  IfNotExist, %ScriptNoExt%.ini
    {
;     MsgBox, 64, %ScriptName% %ScriptVersion%, Die ini-Datei wurde nicht gefunden.`r`n%ScriptNoExt%.ini wird erstellt.
      FileAppend,
        (
[Ordner]
Quelle=%A_MyDocuments%
Ziel=
`;Robocopy akzeptiert UNC-Netzwerkpfade, z.B.\\<Servername>\Pfad

[Schalter]
Minuten=2
Logdateiname=%A_ScriptDir%\robocopy.log
`;Minuten: nach n Minuten erneut synchronisieren
`;Logdateiname:  Ausgabedatei - wird beim Programmstart überschrieben

[Monitor]
RCMTimer=3000
LogMaxMB=32
`;RCMTimer: Zeitabstand der von %ScriptName% durchgeführten Überprüfungen
`;LogMaxMB: max. Größe der Logdatei; Neustart beim Überschreiten
        ), %ScriptNoExt%.ini
    }
  IniRead, rcm_Src, %ScriptNoExt%.ini, Ordner,   Quelle, %A_Space%
  IniRead, rcm_Des, %ScriptNoExt%.ini, Ordner,   Ziel, %A_Space%
  IniRead, rcm_MOT,  %ScriptNoExt%.ini, Schalter, Minuten, %A_Space%
  IniRead, rcm_MON,  %ScriptNoExt%.ini, Schalter, Changes, %A_Space%
  IniRead, rcm_LD,  %ScriptNoExt%.ini, Schalter, Logdateiname, %A_Space%

  IniRead, _FFT,  %ScriptNoExt%.ini, Schalter, FFT, 1
  IniRead, _FP,  %ScriptNoExt%.ini, Schalter, FP, 1
  IniRead, _NDL,  %ScriptNoExt%.ini, Schalter, NDL, 1
  IniRead, _NS,  %ScriptNoExt%.ini, Schalter, NS, 1
  IniRead, _XJ,  %ScriptNoExt%.ini, Schalter, XJ, 1
  IniRead, _XO,  %ScriptNoExt%.ini, Schalter, XO, 0
  IniRead, _Z,  %ScriptNoExt%.ini, Schalter, Z, 0
  IniRead, _DST,  %ScriptNoExt%.ini, Schalter, DST, 0
  IniRead, rc_Dir,  %ScriptNoExt%.ini, Ordner, RobocopyDir, %A_Space%
  IniRead, rcm_Standby,  %ScriptNoExt%.ini, Monitor, AutoStandBy, 1
  IniRead, rcm_Timer,  %ScriptNoExt%.ini, Monitor, RCMTimer, 3000
  IniRead, rcm_LogMax,  %ScriptNoExt%.ini, Monitor, LogMaxMB, 32
  rcm_Switch := _FFT . _FP . _NDL . _NS . _XJ . _XO . _Z . _DST ; für Vergleich auf Änderungen
Return

;------------------------------------------------------------------------------

ROBOCOPYSTART:
  IfExist, %A_ScriptDir%\robocopy.exe
    {
      rc_Dir = %A_ScriptDir%
    }
  Else IfExist, %A_WinDir%\system32\robocopy.exe
    {
      rc_Dir = %A_WinDir%\system32
    }
  Else IfExist, %A_WinDir%\robocopy.exe
    {
      rc_Dir = %A_WinDir%
    }
  Else
    {
      If !(rc_Dir) ; i.e. it's blank
        {
          FileSelectFolder, rc_Dir, *%A_WinDir%, 0, Wählen Sie den Ordner, in dem sich robocopy.exe befindet.
          IfNotExist, %rc_Dir%\robocopy.exe
            {
              MsgBox, 48, %ScriptName% %ScriptVersion%, Die Datei «robocopy.exe» wurde in dem angegebenen Ordner nicht gefunden.`nBitte installieren Sie zunächst Robocopy!`n`nHinweise zur Installation finden Sie auf der OPHTHALMOSTAR-Webseite.`n(http://%HomePage%/robocopy.htm)`n`n%ScriptName% wird nun beendet.
              ExitApp
            }
          IniWrite, %rc_Dir%, %ScriptNoExt%.ini, Ordner, RobocopyDir
        }
    }
  FileGetVersion, rc_version, %rc_Dir%\robocopy.exe
  IfNotExist, exclude.rcj
    {
      FileAppend,
        (

        ), *exclude.rcj
    }
  ; IfNotExist, %rcm_Src% ; funktioniert nicht; ERROR ist gilt als vorhanden
  If ! InStr(FileExist(rcm_Src), "D") ; would be true only if the file exists and is a directory
    {
;      NotExistingFolder = Quellordner
;      NotExistFolderVar := rcm_Src
;      GoSub, MSGBOX7
      NotExistMsg("Quellordner", rcm_Src)
      Return
    }
  Else If ! InStr(FileExist(rcm_Des), "D") ; would be true only if the file exists and is a directory
    {
;      NotExistingFolder = Zielordner
;      NotExistFolderVar := rcm_Des
;      GoSub, MSGBOX7
      NotExistMsg("Zielordner", rcm_Des)
      Return
    }
  If rcm_MOT not between 1 and 99
    {
      rcm_MOT = 1
      IniWrite, %rcm_MOT%, %ScriptNoExt%.ini, Schalter, Minuten
    }
  If rcm_MON not between 1 and 99
    {
      rcm_MON = 1
      IniWrite, %rcm_MON%, %ScriptNoExt%.ini, Schalter, Changes
    }
  If rcm_LD =
    {
      rcm_LD = %A_ScriptDir%\robocopy.log
      IniWrite, %rcm_LD%, %ScriptNoExt%.ini, Schalter, Logdateiname
    }
  IfInString, rcm_Src, %A_Space%
      rcSrc = "%rcm_Src%"
  Else
      rcSrc = %rcm_Src% ; mit Anführungszeichen keine «nur Laufwerkbuchstaben» möglich
  IfInString, rcm_Des, %A_Space%
      rcDes = "%rcm_Des%"
  Else
      rcDes = %rcm_Des%
Var =
Var := _FFT ? Var . " /FFT" : Var
Var := _FP ?  Var . " /FP"  : Var
Var := _NDL ? Var . " /NDL" : Var
Var := _NS ?  Var . " /NS"  : Var
Var := _XJ ?  Var . " /XJ"  : Var
Var := _XO ?  Var . " /XO"  : Var
Var := _Z ?   Var . " /Z"   : Var
Var := _DST ? Var . " /DST" : Var
Run, %rc_Dir%\robocopy.exe %rcSrc% %rcDes% %Var% /E /PURGE /MOT:%rcm_MOT% /MON:%rcm_MON% /X /NP /R:0 /JOB:exclude /LOG:"%rcm_LD%",, Hide|UseErrorLevel, rc_PID
/*
DAT nur ausgewählte Datei-Informationen kopieren (Kopierflags, Standard: /COPY:DAT,
		D: Datei-Inhalt, A: Attribute, T: Zeitstempel)
.DST (Daylight Saving Time) Sommerzeit wird erkannt. Ab Version XP026.
MIR	Spiegelt eine Verzeichnisstruktur (entspricht /E mit /PURGE: /E kopiert alle Unterver-
		zeichnisse (auch leere); gleichzeitig löscht /PURGE im Zielordner alles, was in der
		Quelle nicht vorhanden ist.)
.NP	Kein Prozentsatz - der Prozentsatz kopierter Elemente wird nicht angezeigt.
		Fortschrittsinformationen abschalten (für Log-Datei, ist sonst kaum lesbar)
R		Anzahl von Wiederholungsversuchen bei fehlerhaften Kopiervorgängen. Standard 1 Million (wenn keine
		Anqabe gemacht wird)!
S   Unterordner werden kopiert (excluding empty ones)
Z		Kopiert Daten im Wiederaufnahmemodus. Sollte die Übertragung abbrechen, ergänzt
		Robocopy unvollständige Dateien beim nächsten Durchlauf im Zielordner, ohne sie erneut
		vollständig zu kopieren. Dieser "Restartable Mode" funktioniert aber nur im Netzwerk.
ZB	kopiert große Dateien auch bei Netzwerkaussetzern (s.o.). Im Fall einer Zugriffsverweigerung
		wird der Backup Mode verwendet (was immer das auch heisst).
.XO	Exlude Older: Ist die Zieldatei neuer als die Quelldatei, dann wird sie nicht überschrieben
NC  No Classes: Klassen sind EXTRA, NEUER usw.
.NS  No Size - don't log file sizes.
NDL No Directory List - don't log directory names.
X:  Reports all files tagged as “Extra”(including files not selected).
.FP  Full Path: zeigt den Pfadnamen in der Logdatei an.
.FFT FAT File Times (2-second granularity). Zeitstempel von Quell- und Zieldatei wie bei FAT in 2s Intervallen
*/
  If ErrorLevel
    {
      ; IniDelete, %ScriptNoExt%.ini, Ordner, RobocopyDir
      MsgBox, 20, %ScriptName% %ScriptVersion%, robocopy.exe konnte nicht gestartet werden.`nMöchten Sie die Einstellungen überpüfen?`n`n«Nein» beendet %ScriptName%.
      IfMsgBox, Yes
          GoSub, OPTIONEN
      Else IfMsgBox, No
          ExitApp
    }
  Else
    {
      Gui, 5: +LastFound +AlwaysOnTop -Caption +Owner +Border ; +Owner avoids a taskbar button.
      SplashGUIID := WinExist()
      Gui, 5: Font, s9 norm, MS Sans Serif
      Gui, 5: Color, c%SplashColor%
      Gui, 5: font, s9 bold
      Gui, 5: Add, Text, x5 y8 w200 c%TextColor% Center, Robocopy gestartet (PID %rc_PID%)
;      WinSet, Region, 0-0 w250 h55 R12-12, ahk_id %SplashGUIID% ; Changes the shape of a window
;      Sleep, 10 ; damit Ecken auf jeden Fall rund werden
      Gui, 5: Show, w210 h30 NA ; WinSet funktioniert nur mit DetectHiddenWindows
;      Gui, 5: Show, w250 h55 NA ; WinSet funktioniert nur mit DetectHiddenWindows
      Alpha = 255
      SetTimer, SPLASHGUI, -1
      Suspend, Off
      GoSub, TRAYRENAME ; Menu, Tray, Rename, Fortsetzen, Anhalten
      Menu, Tray, Tip, %ScriptName%`nQuelle: %rcm_Src%`nZiel: %rcm_Des%
      RobocopyTime := A_Now
      SysGet, WorkArea, MonitorWorkArea
      WorkAreaWidth := WorkAreaRight - WorkAreaLeft
      WorkAreaHeight := WorkAreaBottom - WorkAreaTop
      SetTimer, MONITORING, %rcm_Timer%
/*    funktioniert nicht zuverlässig
      IfWinExist, ahk_id %OptiGUIID%
        {
          GuiControl, 4: Show, StatusInfo
          ControlSetText, Static16, Robocopy PID %rc_PID%
        }
*/
    }
Return

SPLASHGUI:
  WinSet, Transparent, %Alpha%, ahk_id %SplashGUIID%
  EnvSub, Alpha, 5
	SetTimer, SPLASHGUI, % (Alpha=0 ? "Off" : (Alpha<100 ? 8 : (Alpha<150 ? 16 : 32)))
	SetTimer, GUI5CLOSE, % (Alpha=0 ? -1 : "Off")
Return

GUI5CLOSE:
  Gui, 5: Destroy
Return

;------------------------------------------------------------------------------

MONITORING:
  If (A_IsSuspended)
      Return
  ;  rcm_Counter := rcm_Counter = 10 ? 1 : rcm_Counter + 1
  ;  If rcm_Counter = 1
  ;    {
  ;      ; Calculate the size of a folder, including the files in all its subfolders:
  ;      ; SetBatchLines, -1  ; Make the operation run at maximum speed.
  ;      SrcSizeKB = 0
  ;      Loop, %rcm_Src%\*.*, , 1
  ;          SrcSizeKB += %A_LoopFileSizeKB%
  ;      Reserve := SrcSizeKB/10
  ;      SrcSizeKB += %Reserve%
  ;      SrcSizeMB := Round(SrcSizeKB/1024)
  ;      DesSizeKB = 0
  ;      Loop, %rcm_Des%\*.*, , 1
  ;          DesSizeKB += %A_LoopFileSizeKB%
  ;      DesSizeMB := Round(DesSizeKB/1024)
  ;      DriveSpaceFree, FreeSpace, %rcm_Des%
  ;      DesSizeMB += %FreeSpace%
  ;    }
  FileGetSize, LogSize, %rcm_LD%, M
  Process, Exist, %rc_PID% ; robocopy.exe
  If ErrorLevel = 0
    {
      If (A_ExitReason) ; keine Fehlermeldung wenn PC herutergefahren wird
        GoSub, SCRIPTEXIT  ; Return
      Sleep, 1000
      Suspend, On
      GoSub, TRAYRENAME ; Menu, Tray, Rename, Anhalten, Fortsetzen
      IfWinExist, ahk_id %OptiGUIID%
          GuiControl, 4: Hide, StatusInfo
      MsgBox, 20, %ScriptName% %ScriptVersion%, Robocopy wurde beendet (PID %rc_PID%).`n`nMöchten Sie die Einstellungen kontrollieren`nbeziehungsweise Robocopy neu starten?`n`n«Nein» beendet %ScriptName%.
      IfMsgBox, Yes
        {
          GoSub, OPTIONEN
          Return ; sonst wird MONITORING wieder angestellt!
        }
      Else
          ExitApp
    }
  If ! InStr(FileExist(rcm_Src), "D") ; IfNotExist, %rcm_Src%
    {
;      NotExistingFolder = Quellordner
;      NotExistFolderVar := rcm_Src
;      GoSub, MSGBOX7
      NotExistMsg("Quellordner", rcm_Src)
      Return
    }
  If LogSize > %rcm_LogMax%
    {
      TrayTip, %ScriptName%, Die Logdatei wird gelöscht`, da sie die`nmaximale Größe überschritten hat.`nHierzu wird Robocopy neu gestartet.,, 17
      Sleep, 3000 ; SetTimer funktioniert hier nicht
      TrayTip
      GoSub, PROCESSCLOSE
      Sleep, 2000 ; sonst Meldung für Robocopy-Ende und -Start gleichzeitig
      GoSub, ROBOCOPYSTART ; FileDelete, %rcm_LD%  funktioniert nicht, Robocopy blockiert
    }
  If ! InStr(FileExist(rcm_Des), "D") ; IfNotExist, %rcm_Des%
    {
;      NotExistingFolder = Zielordner
;      NotExistFolderVar := rcm_Des
;      GoSub, MSGBOX7
      NotExistMsg("Zielordner", rcm_Des)
      Return
    }
  ;  If rcm_Counter = 1
  ;    {
  ;
  ;      If DesSizeMB < %SrcSizeMB%
  ;          If ! rcm_NoDesMon
  ;              MsgBox, 52, %ScriptName% %ScriptVersion%, Der Speicherplatz im Zielordner ist knapp oder nicht ausreichend.`n`nQuellordner: %SrcSizeMB% MB`nZielordner: %DesSizeMB% MB`n`nMöchten Sie einen anderen Zielordner auswählen?
  ;      IfMsgBox, Yes
  ;        {
  ;          GoSub, OPTIONEN
  ;          Return
  ;        }
  ;    }
; NotExistFolderVar = ;weiß nicht ob nötig
Return
; /MONITORING

STICKMODE:
/*
An if-statement that contains an expression is differentiated from a traditional
if-statement such as If FoundColor <> Blue by making the character after the word "if"
an open-parenthesis. Although this is usually accomplished by enclosing the entire expression
in parentheses, it can also be done with something like if (x > 0) and (y > 0).
In addition, the open-parenthesis may be omitted entirely if the first item after the word
"if" is a function call or an operator such as "not" or "!".
*/
  If InStr(FileExist(rcm_Des), "D") and InStr(FileExist(rcm_Src), "D")
    {
      SetTimer, STICKMODE, Off
      GoSub, ROBOCOPYSTART
    }
Return

;------------------------------------------------------------------------------
^#F9::
OPTIONEN:
  SetTimer, MONITORING, Off
  SetTimer, STICKMODE, Off
  Gui, 4: Destroy
  Gui, 4: +LastFound
  OptiGUIID := WinExist()
  Gui, 4: Font, s9 norm, MS Sans Serif
;  Gui, 4: Add, Tab2, w330 h248, Ordner|Schalter|Ausschluss|Überwachung|Optionen|Tipps
  Gui, 4: Add, Tab2, w330 h248 vOptTab, Ordner|Schalter|Ausschluss|Monitor|Optionen|Tipps
  Gui, 4: Tab, 1
  Gui, 4: Add, Text, xm+12 ym+35, Bestimmen Sie, welche Ordner synchronisiert werden sollen.
  Gui, 4: Add, GroupBox, w310 h70 xm+10 ym+60, &Quelle (Original)
  Gui, 4: Add,  Edit, xm+17 yp+30 w244 r1 vQuelle, %rcm_Src% ; ReadOnly ?
  Gui, 4: Add, Button, gQUELLE x+4 yp-1 w48, &Ändern

  Gui, 4: Add, GroupBox, w310 h85 xm+10 ym+148, &Ziel (Sicherheitskopie)
  Gui, 4: Add,  Edit, xm+17 yp+30 w244 r1 vZiel, %rcm_Des% ; ReadOnly ?
  Gui, 4: Add, Button, gZIEL x+4 yp-1 w48, Ä&ndern
  Gui, 4: Add, Text, cMaroon xm+17 yp+32, In der Quelle nicht existente Dateien werden im Ziel gelöscht!

  Gui, 4: Tab, 2
  Gui, 4: Add, Text, xm+12 ym+35, Legen Sie fest, mit welchen Schaltern Robocopy gestartet wird.
  Gui, 4: Add, GroupBox, w310 h90 xm+10 ym+60, &Monitor
  Gui, 4: Add, Text, xm+17 yp+27, Erneut sichern nach
  Gui, 4: Add,  Edit, xm+130 yp-2 w45 Number Limit2 vIntervall
  Gui, 4: Add,  UpDown, Range1-99, %rcm_MOT%
  Gui, 4: Add, Text, xm+188 yp+2, Minute(n)

  Gui, 4: Add, Text, xm+94 yp+32, und
  Gui, 4: Add,  Edit, xm+130 yp-2 w45 Number Limit2 vChanges
  Gui, 4: Add,  UpDown, Range1-99, %rcm_MON%
  Gui, 4: Add, Text, xm+188 yp+2, Veränderung(en). ; wurden.

  Gui, 4: Add, GroupBox, w310 h70 xm+10 ym+163, &Logdatei
  Gui, 4: Add,  Edit, xm+17 yp+30 w244 r1 vLogfile, %rcm_LD%
  Gui, 4: Add, Button, gLOGFILE x+4 yp-1 w48, &Ändern

  Gui, 4: Tab, 3
  Gui, 4: Add, Button, gEXCLUDENEW x20 ym+24 w150, &Beispiel-Datei neu anlegen
  Gui, 4: Add, Button, gEXCLUDEHELP x170 ym+24 w140, &Hilfe zur Exclude-Datei
  Gui, 4: Add, Text, 0x1000 x17 y52 w314 h2
  Gui, 4: Add,  Edit, vExcludeEdit WantTab -Wrap W314 R14

  Gui, 4: Tab, 4
  Gui, 4: Add, Text, xm+12 ym+35, Einstellungen für die Überwachung durch %ScriptName%.
  Gui, 4: Add, GroupBox, w310 h80 xm+10 ym+60, &Zeitabstand
  Gui, 4: Add, Text, xm+17 yp+30, Kontrollintervall (Sekunden):
  rcm_Temp := Round(rcm_Timer/1000)
  Gui, 4: Add,  DropDownList, xm+260 yp-1 w50 Choose%rcm_Temp% vRCMTimer, 1|2|3|4|5|6|7|8|9|10|11|12|13|14|15|16|17|18|19|20|21|22|23|24|25|26|27|28|29|30|31|32|33|34|35|36|37|38|39|40|41|42|43|44|45|46|47|48|49|50|51|52|53|54|55|56|57|58|59|60
  ;  Gui, 4: Add, Text, xm+17 yp+27, Die Ordnerkapazität wird nur bei jedem 10. Mal verglichen.
  Gui, 4: Font, underline
  Gui, 4: Add, Text, xm+17 yp+27 cNavy gINFOMSGBOX , Informationen zur Überwachung
  Gui, 4: Font, norm

  Gui, 4: Add, GroupBox, w310 h80 xm+10 ym+153, &Ausgabe
  Gui, 4: Add, Text, xm+17 yp+30, Maximale Größe der Logdatei (MB):
  rcm_Temp := (rcm_LogMax = 256 ? 8 : (rcm_LogMax = 128 ? 7 : (rcm_LogMax = 64 ? 6 : (rcm_LogMax = 32 ? 5 : (rcm_LogMax = 16 ? 4 : (rcm_LogMax = 8 ? 3 : (rcm_LogMax = 4 ? 2 : (rcm_LogMax = 2 ? 1 : 5))))))))
  Gui, 4: Add,  DropDownList, xm+260 yp-1 w50 Choose%rcm_Temp% vLogMaxMB, 2|4|8|16|32|64|128|256
  Gui, 4: Add, Text, xm+17 yp+27, Bei Überschreitung wird Robocopy neu gestartet.

  Gui, 4: Tab, 5
  Gui, 4: Add, Checkbox, xm+12 ym+35 vAutoStart Checked, Automatischer Start beim Anmelden des Windows-Benutzers
  IfNotExist, %A_Startup%\%ScriptNoExt%.lnk
      GuiControl, 4:, AutoStart, 0
  Gui, 4: Add, Checkbox, xm+12 yp+26 vAutoStandBy Checked%rcm_Standby%, Automatisches Standby bei fehlendem Ziel- oder Quellordner
;  Gui, 4: Add, GroupBox, w310 h150 xm+10 ym+83, &optionale Schalter
; Gui, 4: Add, Text, xm+12 ym+93, Optionale Robocopy-Schalter:
  Gui, 4: Add, Text, xm+12 ym+85, Optionale Robocopy-Schalter:`n(Bitte Text anklicken`, um Erklärungen zu lesen)
  Gui, 4: Add, Button, xm+245 ym+88 w75 gSWITCHES, Standard
  Gui, 4: Default ; sonst funktioniert LV_Add nicht
  Gui, 4: Add, ListView, xm+10 ym+115 r7 w310 gLIST_VIEW vSwitch_LV Checked ReadOnly -Multi -Hdr AltSubmit Grid, Parameter|Beschreibung
  LV_ModifyCol(1, "50")
  LV_ModifyCol(2, "256")
  LV_Add("Check" . _FFT, "FFT", "(FAT File Times) Zeitstempel in 2-Sekunden Intervallen (wie bei FAT)")
  LV_Add("Check" . _FP , "FP", "(Full Path) Pfadnamen in der Logdatei anzeigen")
  LV_Add("Check" . _NDL, "NDL", "(No Directory List) Ordnernamen nicht in der Logdatei protokollieren")
  LV_Add("Check" . _NS , "NS", "(No Size) Größenangaben nicht in der Logdatei protokollieren")
  LV_Add("Check" . _XJ , "XJ", "(Exclude Junctions) Ausschluss von Junctions (vermeidet Rekursionen)")
  LV_Add("Check" . _XO , "XO", "(Exclude Older) Zieldatei nicht überschreiben, wenn sie jünger ist.")
  LV_Add("Check" . _Z  , "Z", "Wiederaufnahmemodus. Große Dateien werden auch bei Netzwerkaussetzern kopiert.`nDer Gebrauch dieser Option kann die Performance deutlich reduzieren.`nSie sollten sie nur verwenden`, wenn Sie sie wirklich benötigen.")
  LV_Add("Check" . _DST, "DST", "(Daylight Saving Time) Sommerzeit erkennen. Ab Version XP026.")
/*
LV_Add("Check", "NP", "(No Percentage) Fortschrittsinformationen nicht in der Logdatei protokollieren")

If you use /Z, /B, or /ZB, this can decrease Robocopy performance and throughput significantly, as these options involve extra overhead. These options are therefore only recommended when experience indicates you really need them.
*/
  Gui, 4: Tab, 6
  Gui, 4: Font, Bold
  Gui, 4: Add, Text, xm+17 ym+30, Ordner
  Gui, 4: Font
  Gui, 4: Add, Text, xm+14 yp+15, Quell- und Zielordner sollten sich sich auf unterschiedlichen`nSpeichermedien des eigenen Rechners und/oder eines an-`nderen Rechners im Netzwerk befinden.`nRobocopy akzeptiert UNC-Adressen für Netzwerkpfade.`nBeispiel: \\Servername\Freigabename\Pfad
  Gui, 4: Font, Bold
  Gui, 4: Add, Text, xm+17 ym+120, Schalter
  Gui, 4: Font
  Gui, 4: Add, Text, xm+14 yp+15, Die optimalen Werte für das Monitoring hängen von der Leis-`ntungsfähigkeit des Rechners, der Anzahl der zu überwachen-`nden Dateien und der Datenfluktuation ab. Im Hinblick auf die`nDatensicherheit sollten Sie geringe Werte ausprobieren.
  Gui, 4: Add, Text, xm+14 ym+192, Grundsätzlich ist es möglich`, %ScriptName% mehrfach zu`nstarten. Sinnvoll ist dies nur`, wenn sich die Programmdateien`n(resp. ini-Dateien) in unterschiedlichen Ordnern befinden.

  Gui, 4: Tab
  Process, Exist, %rc_PID%
  If ErrorLevel = %rc_PID%
    {
      Gui, 4: Font, underline
      Gui, 4: Add, Text, cNavy gLAUNCHMSGBOX vStatusInfo xm+12 y265, Robocopy PID %rc_PID%
      Gui, 4: Font, norm
    }
  Gui, 4: Add, Button, gSETTINGSOK Default x180 y260 w75, &OK
  Gui, 4: Add, Button, gSETTINGSCANCEL x+10 W75, &Abbrechen
  Gui, 4: Show,, %ScriptName% Einstellungen
  GoSub, EXCLUDEREAD
; GoSub, ColorChange
  OnMessage(0x200, "WM_MOUSEMOVE4")
  WM_MOUSEMOVE4(wParam, lParam)
  {
    Global hCurs
    IfNotEqual, A_Gui, 4, Return
    MouseGetPos,,,, ctrl
    If ctrl in Static11,Static20
        DllCall("SetCursor", "UInt", hCurs)
    Return
  }
Return
;------------------------------------------------------------------------------
;ColorChange:
;GuiControlGet, Quelle, 4:
;Gui, 4: Font, cRed ; If desired, use a line like this to set a new default font for the window.
;GuiControl, 4: Font, Quelle  ; Put the above font into effect for a control.
;GuiControl, 4: Font, Ziel  ; Put the above font into effect for a control.
;Return

LIST_VIEW:
  Critical ; ensures that all "I" notifications are received
  If A_GuiEvent = DoubleClick
    {
    If (LV_GetNext(A_EventInfo - 1, "Checked") = A_EventInfo)
      LV_Modify(A_EventInfo, "-Check")
    Else
       LV_Modify(A_EventInfo, "+Check")
    }
  If (A_GuiEvent = "I" AND InStr(ErrorLevel, "S", true))
    {
    LV_GetText(var, A_EventInfo, 2)
    ToolTip, %Var%
    SetTimer, ToolTipOff, -5000
    }
Return

ToolTipOff:
  Tooltip
Return

SWITCHES:
  LV_Modify(1, "+Check")
  LV_Modify(2, "+Check")
  LV_Modify(3, "+Check")
  LV_Modify(4, "+Check")
  LV_Modify(5, "+Check")
  LV_Modify(6, "-Check")
  LV_Modify(7, "-Check")
  LV_Modify(8, "-Check")
Return

INFOMSGBOX:
  Gui, 4: +OwnDialogs ; become modal, no interact with the GUI window until dismissing the dialog.
  InfoText =
    (
%ScriptName% überprüft im Sekunden-Abstand
`n•%A_Space% ob der Robocopy-Prozess weiterhin aktiv ist,
`n•%A_Space% ob der Zielordner weiterhin vorhanden ist,
`n•%A_Space% ob der Quellordner weiterhin vorhanden ist,
`n•%A_Space% ob die Logdatei eine bestimmte Größe erreicht hat.
    )
  MsgBox, 64, %ScriptName% %ScriptVersion%, %InfoText%
Return

LAUNCHMSGBOX:
;  DetectHiddenWindows, On ; für WinGet ProcessName
  Process, Exist, %rc_PID% ; robocopy.exe
  If ErrorLevel = 0 ; falls während Gui1 Prozess extern gelöscht wurde
    {
      Suspend, On
      GoSub, TRAYRENAME ; Menu, Tray, Rename, Anhalten, Fortsetzen
      GuiControl, 4: Hide, StatusInfo
      Return
    }
  Gui, 4: +OwnDialogs ; become modal, no interact with the GUI window until dismissing the dialog.
  FormatTime, rcm_Temp, %RobocopyTime%, d.M.yy %A_Space% H:mm
  WinGet, rc_Name, ProcessName, ahk_pid %rc_PID%
  FileGetVersion, rc_version, %rc_Dir%\%rc_Name%
  MsgBox, 292, %ScriptName% %ScriptVersion%, Prozess: %A_Tab% %rc_Name%`nVersion: %A_Tab% %rc_Version%`nPfad: %A_Tab% %rc_Dir%`nPID: %A_Tab% %rc_PID%`nStart: %A_Tab% %rcm_Temp%`n`nMöchten Sie den Robocopy-Prozess beenden?
  IfMsgBox, Yes
    {
      Process, Exist, %rc_PID% ; Sets ErrorLevel to PID, otherwise 0
      If (ErrorLevel)
          GoSub, PROCESSCLOSE
    }
Return

QUELLE:
  ; Ordner =
  Gui, 4: +OwnDialogs ; become modal, no interact with the GUI window until dismissing the dialog.
  FileSelectFolder, Ordner, *%rcm_Src%, , Wählen sie den Quellordner.
  ;  If not Ordner  ; The user canceled the dialog.
  ;      Return
  If (!Ordner Or !InStr(FileExist(Ordner), "D"))
      Return
  ;  Else If ! InStr(FileExist(Ordner), "D") ; would be true only if the file exists and is a directory
  ;      MsgBox, 16, %ScriptName% %ScriptVersion%, Auswahl ungültig.
/*
  ; Check if the last character of the folder name is a backslash, which happens for root
  ; directories such as C:\. If it is, remove it to prevent a double-backslash later on.
  StringRight, rcm_Temp, Ordner, 1
  If rcm_Temp = \
      StringTrimRight, Ordner, Ordner, 1  ; Remove the trailing backslash.
  StringLeft, rcm_Temp, Ordner, 2 ; für UNC-Adressen: \\usw.
  StringTrimLeft, rcm_Temp, Ordner, (rcm_Temp = "\\" ? 2 : 0)
  StringSplit, rcm_Temp, rcm_Temp, \
  ;  MsgBox, rcm_Temp %rcm_Temp%`nrcm_Temp2 %rcm_Temp2%
  If rcm_Temp2 =
    {
      MsgBox, 48, %ScriptName% %ScriptVersion%, Robocopy kann %Ordner% nicht als Quelle verwenden.`nSie müssen einen Ordner auswählen.
      GoSub, QUELLE
    }
*/
  ;  Else
  GuiControl, 4: , Quelle, %Ordner%
Return
;------------------------------------------------------------------------------

ZIEL:
  Gui, 4: +OwnDialogs  ; Forces user to dismiss the following dialog before using main window.
  Files =
  Ordner =
  FileSelectFolder, Ordner, *%rcm_Des%, , Wählen sie den Zielordner.`nDateien und Verzeichnisse`, die in der Quelle nicht existieren`, werden während der Synchronisation im Zielordner gelöscht!
  If (!Ordner Or !InStr(FileExist(Ordner), "D"))
      Return
  SplashImage,, CWEEEEEE b1 FS10 W100, Bitte warten...
  Loop, %Ordner%\*.*,, 1
      Files = %A_Index%
  SplashImage, Off
  If (Files > 0)
      MsgBox, 308, %ScriptName% %ScriptVersion%, Der Ordner "%Ordner%" enthält %Files% Dateien.`nDiese werden möglicherweise während der Synchronisation gelöscht.`n`nMöchten Sie den Ordner trotzdem als Zielordner festlegen?
  IfMsgBox, No
    {
      GoSub, ZIEL
      Return
    }
  GuiControl, 4:, Ziel, %Ordner%
Return
;------------------------------------------------------------------------------

LOGFILE:
  Gui, 4: +OwnDialogs ; become modal, no interact with the GUI window until dismissing the dialog.
  FileSelectFile, Datei, 59, %rcm_LD%, Robocopy Logdatei, Logdateien (*.log)
  ;  SplitPath, Datei,,,, name_no_ext
  If not Datei
      Return
  GuiControl, 4:, Logfile, %Datei%
Return
;------------------------------------------------------------------------------

SETTINGSOK:
  Gui, 4: +OwnDialogs ; become modal, no interact with the GUI window until dismissing the dialog.
  Gui, 4: Submit, NoHide
  SplitPath, Logfile,, out_Dir
  If ! InStr(FileExist(out_Dir), "D") ; IfNotExist, %out_Dir%
    {
    MsgBox, 48, %ScriptName% %ScriptVersion%, Der Pfad zur Logdatei existiert nicht`n(%out_Dir%).`nBitte korrigieren Sie die Eingabe.
    GuiControl, 4: Choose, OptTab, 2
    GuiControl, 4: Focus, Logfile
    Return
    }

  If ! InStr(FileExist(Quelle), "D") ; would be true only if the file exists and is a directory
    {
    MsgBox, 292, %ScriptName% %ScriptVersion%, Der Quellordner wurde nicht gefunden.`nMöchten Sie einen neuen Ordner angeben?`n`n«Nein» versetzt %ScriptName% in den`nStandby-Modus für mobile Datenträger.
    IfMsgBox, Yes
      {
      GuiControl, 4: Choose, OptTab, 1
      GuiControl, 4: Focus, Quelle
      Return
      }
    }
  Else If ! InStr(FileExist(Ziel), "D") ; would be true only if the file exists and is a directory
    {
    MsgBox, 292, %ScriptName% %ScriptVersion%, Der Zielordner wurde nicht gefunden.`nMöchten Sie einen neuen Ordner angeben?`n`n«Nein» versetzt %ScriptName% in den`nStandby-Modus für mobile Datenträger.
    IfMsgBox, Yes
      {
      GuiControl, 4: Choose, OptTab, 1
      GuiControl, 4: Focus, Ziel
      Return
      }
    }

  If (AutoStart)
    {
    IfNotExist, %A_Startup%\%ScriptNoExt%.lnk
      {
      FileCreateShortcut, %A_ScriptFullPath%, %A_Startup%\%ScriptNoExt%.lnk, %A_ScriptDir%,, Werkzeug für Robocopy im Monitormodus
      If (ErrorLevel)
        MsgBox, 8208, %ScriptNoExt%, Die Autostart-Verknüpfung konnte nicht erstellt werden.
      }
    }
  Else
    {
    FileDelete, %A_Startup%\%ScriptNoExt%.lnk
    If ErrorLevel = 0
      MsgBox, 64, %ScriptNoExt%, %A_Startup%\%ScriptNoExt%.lnk wurde gelöscht.
    }
  If AutoStandBy <> %rcm_Standby%
    {
    rcm_Standby := AutoStandBy
    IniWrite, %rcm_Standby%, %ScriptNoExt%.ini, Monitor, AutoStandBy
    }
  RCMTimer := RCMTimer * 1000
  _FFT := (LV_GetNext(0, "Checked") = 1) ? 1 : 0
  _FP  := (LV_GetNext(1, "Checked") = 2) ? 1 : 0
  _NDL := (LV_GetNext(2, "Checked") = 3) ? 1 : 0
  _NS  := (LV_GetNext(3, "Checked") = 4) ? 1 : 0
  _XJ  := (LV_GetNext(4, "Checked") = 5) ? 1 : 0
  _XO  := (LV_GetNext(5, "Checked") = 6) ? 1 : 0
  _Z   := (LV_GetNext(6, "Checked") = 7) ? 1 : 0
  _DST := (LV_GetNext(7, "Checked") = 8) ? 1 : 0
  If rcm_Switch <> % _FFT . _FP . _NDL . _NS . _XJ . _XO . _Z . _DST
    GoSub, SPEICHERN
  Else If Quelle <> %rcm_Src%
    GoSub, SPEICHERN
  Else If Ziel <> %rcm_Des%
    GoSub, SPEICHERN
  Else If Intervall <> %rcm_MOT%
    GoSub, SPEICHERN
  Else If Changes <> %rcm_MON%
    GoSub, SPEICHERN
  Else If Logfile <> %rcm_LD%
    GoSub, SPEICHERN
  Else If RCMTimer <> %rcm_Timer%
    GoSub, SPEICHERN
  Else If LogMaxMB <> %rcm_LogMax%
    GoSub, SPEICHERN
  Else If ExcludeEdit <> %ExcludeText%
    GoSub, SPEICHERN
  Else
    {
    GoSub, SETTINGSCANCEL
    Process, Exist, %rc_PID% ; robocopy.exe
    If (ErrorLevel = 0 or rc_PID = "")
      GoSub, SCRIPTRELOAD ; ROBOCOPYSTART allein reicht nicht
    }
Return
;------------------------------------------------------------------------------

SPEICHERN:
  Gui, 4: Destroy
  rcm_Src := Quelle
  rcm_Des := Ziel
  rcm_MOT := Intervall
  rcm_MON := Changes
  rcm_LD := Logfile
  rcm_LogMax := LogMaxMB
  rcm_Timer := RCMTimer
  rcm_Standby := AutoStandBy
  _DST := SubStr(rc_version, -1) = 10 ? 0 : _DST ; funktioniert nicht mit Version XP010
  rcm_Switch := _FFT . _FP . _NDL . _NS . _XJ . _XO . _Z . _DST
  GoSub, EXCLUDESAVE
  GoSub, WRITEINI
/*
  Counter = 3
  Gui, 7: +LastFound -MinimizeBox -MaximizeBox
  CounterID := WinExist()
  Gui, 7: Color, FFFFFF
  Gui, 7: Margin, 10, 10
  Gui, 7: Add, Text, y20, Robocopy wird jetzt neu gestartet. [%Counter%]
  Gui, 7: Add, Button, x65 y55 w75 Default, OK
  Gui, 7: Show, w190 h60, %ScriptName% %ScriptVersion% ; h90
  GuiControl, 7: Hide, OK
  SetTimer, COUNTDOWN, 1000
*/
  GoSub, SCRIPTRELOAD
Return

SETTINGSCANCEL:
4GuiClose: ; 1GuiClose funktioniert nicht!!!
4GuiEscape:
  Gui, 4: Destroy
  SetTimer, MONITORING, %rcm_Timer%
  OnMessage(0x200, "")
  DllCall("DestroyCursor","Uint",hCur)
  Tooltip ; ListView
Return

/*
7GuiClose:
7GuiEscape:
7ButtonOK:
  SetTimer, COUNTDOWN, Off
  Gui, 7: Destroy
  GoSub, SCRIPTRELOAD
Return

COUNTDOWN:
  Counter --
  ControlSetText, Static1, Robocopy wird jetzt neu gestartet. [%Counter%], ahk_id %CounterID%
  If Counter = 0
      GoSub, 7GUICLOSE
Return
*/
;------------------------------------------------------------------------------

WRITEINI:
  IniWrite, %rcm_Src%, %ScriptNoExt%.ini, Ordner,   Quelle
  IniWrite, %rcm_Des%, %ScriptNoExt%.ini, Ordner,   Ziel
  IniWrite, %rcm_MOT%,  %ScriptNoExt%.ini, Schalter, Minuten
  IniWrite, %rcm_MON%,  %ScriptNoExt%.ini, Schalter, Changes
  IniWrite, %rcm_LD%,  %ScriptNoExt%.ini, Schalter, Logdateiname

  IniWrite, %_FFT%,  %ScriptNoExt%.ini, Schalter, FFT
  IniWrite, %_FP%,  %ScriptNoExt%.ini, Schalter, FP
  IniWrite, %_NDL%,  %ScriptNoExt%.ini, Schalter, NDL
  IniWrite, %_NS%,  %ScriptNoExt%.ini, Schalter, NS
  IniWrite, %_XJ%,  %ScriptNoExt%.ini, Schalter, XJ
  IniWrite, %_XO%,  %ScriptNoExt%.ini, Schalter, XO
  IniWrite, %_Z%,  %ScriptNoExt%.ini, Schalter, Z
  IniWrite, %_DST%,  %ScriptNoExt%.ini, Schalter, DST

  IniWrite, %rcm_Standby%, %ScriptNoExt%.ini, Monitor, AutoStandBy
  IniWrite, %rcm_Timer%, %ScriptNoExt%.ini, Monitor, RCMTimer
  IniWrite, %rcm_LogMax%, %ScriptNoExt%.ini, Monitor, LogMaxMB
Return
;------------------------------------------------------------------------------

EXCLUDENEW:
  TextCount = 0
  Loop, read, exclude.rcj
    {
      SearchString = %A_LoopReadLine%
      If StrLen(SearchString) > 0
          TextCount += 1
    }
  If TextCount > 0
      MsgBox, 308, %ScriptName% %ScriptVersion%, Alle bisherigen Einträge gehen verloren.`nMöchten Sie fortfahren?
  IfMsgBox, No
      Return
  FileDelete, exclude.rcj
  FileAppend,
    (
/XF
:: Dateien weglassen (excludes files)
%A_Tab%*.zip
%A_Tab%"Fotos 96*.*"

/XD
:: Ordner weglassen (excludes directories)
%A_Tab%System Volume Information
%A_Tab%C:\Quelle\Ausschluss

:: Beispieleinträge. Bitte im Zweifelsfall  ALLES  LÖSCHEN !!!
:: Andernfalls wird Ihre Datensicherung unvollständig sein.
    ), *exclude.rcj
  FileRead, ExcludeEdit, exclude.rcj  ; Read the file's contents into the variable.
  GuiControl, 4:, ExcludeEdit, %ExcludeEdit%  ; Put the text into the control.
Return
;------------------------------------------------------------------------------

EXCLUDEREAD:
  FileRead, ExcludeText, exclude.rcj  ; Read the file's contents into the variable.
  If ErrorLevel
    {
      GoSub, EXCLUDENEW
      Return
    }
  GuiControl, 4:, ExcludeEdit, %ExcludeText%  ; Put the text into the control.
Return
;------------------------------------------------------------------------------

EXCLUDESAVE:  ; Caller has ensured that ExcludeFileName is not blank.
  IfExist, exclude.rcj
    {
      FileDelete exclude.rcj
      If ErrorLevel
        {
          MsgBox Versuch "exclude.rcj" zu überschreiben schlug fehl.
          Return
        }
    }
  ;  GuiControlGet, ExcludeEdit, 4: ; is still saved to its variable via Gui Submit
  FileAppend, %ExcludeEdit%, *exclude.rcj  ; Save the contents to the file.
Return
;------------------------------------------------------------------------------

EXCLUDEHELP:
/*
owner1 => #1 window
owner  => script's main window
*/
  Gui, 2: +owner4  ; Make Gui #4 the owner Gui #2; muss in einer eigenen Zeile stehen
  Gui, +Disabled  ; Disable main window.
  Gui, 2: Font, s9 norm, MS Sans Serif
  Gui, 2: -MinimizeBox -MaximizeBox ; +AlwaysOnTop -SysMenu +OwnDialogs
  Gui, 2: Color, FFFFFF
  Gui, 2: Add, Text,,`nDie Eingaben in diesem Fenster werden in der Datei exclude.rcj gespeichert (Robocopy Jobfile).`n`nJobfiles sind einfache Text-Dateien mit einem Robocopy-Schalter pro Zeile. Schalter, die einen Doppelpunkt`nenthalten, z.B. /MAX:n, dürfen keine Leerzeichen links und rechts vom Doppelpunkt aufweisen. Vorstehende`nLeerzeichen oder Tabs werden ignoriert. Text, der auf zwei nebeneinander stehende Doppelpunkte folgt, wird`nals Kommentar betrachtet.`n`nMit den Schaltern XF und XD können Sie bestimmte Dateien oder ganze Ordner vom Backup ausschließen.`n`nBitte beachten Sie bei der Vewendung des XD-Schalters, dass die Eingabe von Teilpfaden nicht funktioniert:`n	PARA\ventario :: funktioniert nicht`n	D:\MEDISTAR\PARA\ventario\doku :: funktioniert (kompletter Pfad)`n	ventario :: funktioniert (ohne Backslash)`n`nWeitere Erklärungen finden sich in der Robocopy-Dokumentation (robocopy.doc).
  Gui, 2: Add, Text
  Gui, 2: Add, Button, x220 w95 gEXCLHELPCLOSE Default, Schließen
  Gui, 2: Show, w540, Hilfe zu exclude.rcj
Return
;------------------------------------------------------------------------------

EXCLHELPCLOSE:  ; This section is used by the "about box" above.
2GuiClose:
2GuiEscape:
  Gui, 4: -Disabled  ; Re-enable the main window (must be done prior to the next step).
  Gui, 2: Destroy
  WinActivate, ahk_id %OptiGUIID%
Return
;------------------------------------------------------------------------------

HELPGUI:
  Gui, 3: Destroy
  ;  Gui, +OwnDialogs  ; Forces user to dismiss the following dialog before using main window.
  Gui, 3:Color, FFFFFF
  Gui, 3: Font, s9 norm, MS Sans Serif
  Gui, 3: Add, GroupBox, w680 h420 x10 y0
  Gui, 3: Add, GroupBox, w200 h135 x10 y412, Impressum
  Gui, 3: Add, GroupBox, w482 h135 x208 y412, Links
  Gui, 3: Font, s12 bold, Arial
  Gui, 3: Add, Text, x25 y20, %ScriptName% - Konfiguration und Monitoring für Robocopy im Monitormodus
  Gui, 3: font, s9 norm, Arial
  Gui, 3: Add, Text, x25 y57, %ScriptName% ist ein Hilfsprogramm für den unkomplizierten Einsatz von Robocopy im Monitor-Modus.`n`nRobocopy selbst ist ein Kommandozeilen-Kopierprogramm für Windows von Microsoft. Mit seinen unzähligen Filter-`nmöglichkeiten, Optionen und kryptischen Parameterlisten ist es nicht gerade einfach zu bedienen.`n`n%ScriptName% beschränkt sich auf die Nutzung der herausragendsten Fähigkeit: Im Monitor-Modus läuft Robo-`ncopy dauerhaft und überwacht im Minutenabstand den Inhalt des Quellordners, um die Kopie automatisch auf den`naktuellen Stand zu bringen. Robocopy arbeitet stets inkrementell: Es vergleicht zunächst den Inhalt des Quellordners`nmit dem Ziel, um dann nur solche Dateien zu übertragen, die noch nicht im Zielordner vorhanden oder neuer sind.`nDas Programm verlässt sich dabei nicht auf Archivbits: Um zu entscheiden, ob eine Datei im Zielordner bereits`nidentisch mit der Quelldatei ist, betrachtet Robocopy den Zeitpunkt der letzten Änderung sowie die Größe der Datei.`n`nLeider gibt Robocopy nur wenige Fehlermeldungen aus und schreibt diese lediglich in eine Logdatei. Hier springt `n%ScriptName% zur Seite, indem es regelmäßig überprüft, ob Quell- und Zielordner vorhanden sind, ob die Log-`ndatei nicht zu groß geworden ist und ob Robocopy überhaupt noch als Prozess läuft. Die Logdatei können Sie`nübrigens leicht durch einen Mausklick auf das Tray-Icon öffnen.`n`nBitte beachten Sie, dass die permanente Spiegelung allein als Backup nicht ausreicht: Wenn die Originaldaten be-`nschädigt, unbeabsichtigt geändert oder gelöscht werden, wird Robocopy auch die Sicherheitskopie vernichten.`n`nDie aktuelle Robocopy-Version für WinXP und Win2K ist Bestandteil der frei zugänglichen Windows Server 2003`nResource Kit Tools. Unter Vista ist Robocopy zum standardmäßig vorhandenen System-Tool aufgestiegen und`nbefindet sich im Ordner %windir%\System32. Die Vista-Version ist nicht abwärtskompatibel.
  Gui, 3: Add, Text, x25 y435, Programmautor:
  Gui, 3: Add, Text, x40 y465, Dr. med. Wilhelm Happe
  Gui, 3: Add, Text, x40 y485, Kanalstr. 20, 24159 Kiel
  Gui, 3: Font
  Gui, 3: Font, underline
  Gui, 3: Add, Text, cNavy gHOMEPAGE x40 y515, %HomePage%

  Gui, 3: Font, s9 norm, Arial
  Gui, 3: Add, Text, x235 y435, Windows Server 2003 Resource Kit Tools:
  Gui, 3: Font
  Gui, 3: Font, underline
  Gui, 3: Add, Text, cNavy gRKTOOLS x250 y455, http://www.microsoft.com/downloads/details.aspx?FamilyID=9d467a69-57ff-4ae7-96ee-`nb18c4790cffd&DisplayLang=en
  Gui, 3: font, s9 norm, Arial
  Gui, 3: Add, Text, x235 y495, TechNet Utility Spotlight Robocopy GUI (installiert Robocopy XP026):
  Gui, 3: Font
  Gui, 3: Font, underline
  Gui, 3: Add, Text, cNavy gSYNCTOY x250 y515, http://technet.microsoft.com/en-us/magazine/2006.11.utilityspotlight.aspx
  Gui, 3: Font
  Gui, 3: Add, Button, x300 y558 w75 gHELPGUIOK Default, &Schließen
  Gui, 3: Show, w705 h600, %ScriptName% %ScriptVersion%
  OnMessage(0x200, "WM_MOUSEMOVE3")
Return
;------------------------------------------------------------------------------

HOMEPAGE:
  Run http://%HomePage%/
Return
;------------------------------------------------------------------------------

RKTOOLS:
  Run http://www.microsoft.com/downloads/details.aspx?FamilyID=9d467a69-57ff-4ae7-96ee-b18c4790cffd&DisplayLang=en
Return
;------------------------------------------------------------------------------

SYNCTOY:
  Run http://technet.microsoft.com/en-us/magazine/2006.11.utilityspotlight.aspx
Return
;------------------------------------------------------------------------------

HELPGUIOK:
3GuiClose:
3GuiEscape:
  Gui, 3: Destroy
  OnMessage(0x200, "")
  DllCall("DestroyCursor","Uint",hCur)
Return
;------------------------------------------------------------------------------

NotExistMsg(NotExistingFolder, NotExistFolderVar) {
  Global
  SetTimer, MONITORING, Off
  FileAppend, `n------------------------------------------------------------------------------`n%NotExistingFolder% nicht gefunden : %A_DDD% %A_MMM% %A_DD% %A_Hour%:%A_Min%:%A_Sec% %A_YYYY% (%NotExistFolderVar%)`n------------------------------------------------------------------------------`n, %rcm_LD%
  Menu, Tray, Tip, %ScriptName%`nDer %NotExistingFolder% ist nicht vorhanden.`nEs erfolgt keine Datensicherung.
  If rcm_Standby AND NotExistFolderVar
    {
    TrayTip, %ScriptName%, Der %NotExistingFolder% wurde nicht gefunden.`nDer Standby-Modus wird aktiviert.,, 17
    Settimer, REMOVETRAYTIP, -3000
    GoSub, PROCESSCLOSE
    SetTimer, STICKMODE, %rcm_Timer%
    }
  Else
    {
    If !NotExistFolderVar ; wenn Variable völlig leer ist, d.h. überhaupt kein Pfad vorhanden ist
      {
      MsgBox, 292, %ScriptName% %ScriptVersion%, Der %NotExistingFolder% wurde nicht gefunden.`nMöchten Sie einen neuen Ordner angeben?`n`n«Nein» beendet %ScriptName%.
      IfMsgBox, Yes
        {
        If !rcm_Src   ; i.e. it's blank
          {
          rcm_Src = %A_MyDocuments%
          IniWrite, %rcm_Src%, %ScriptNoExt%.ini, Ordner, Quelle
          ; MsgBox, 64, %ScriptName% %ScriptVersion%, Standard-Quellordner eingetragen., 3
          }
        GoSub, OPTIONEN
        GuiControl, 4: Focus, % NotExistingFolder = "Zielordner" ? "Ziel" : "Quelle"
        }
      Else IfMsgBox, No
        ExitApp
      }
    Else
      {
      rcm_Text =
        (LTrim
        Der %NotExistingFolder% wurde nicht gefunden.
        (%NotExistFolderVar%)
        Möchten Sie einen neuen Ordner angeben?

        Alternativ können Sie das Programm in den Standby-
        Modus für mobile Datenträger versetzen oder beenden.
        Unter «Einstellungen | Optionen» können Sie einstellen,
        dass der Standby-Modus automatisch aktiviert wird.
        )
      Gui, 7: Destroy
      Gui, 7: +LastFound -MinimizeBox -MaximizeBox ; +AlwaysOnTop
      Gui, 7: Font, s9 norm, MS Sans Serif
      Gui, 7: Margin, 15, 10
      Gui, 7: Add, Text, y15, %rcm_Text%
      Gui, 7: Add, Button, y+15 w80 , &Ja
      Gui, 7: Add, Button, Default x+5 yp w80 , &Standby
      Gui, 7: Add, Button, x+5 yp w80 , &Beenden
      SoundPlay, *-1
      Gui, 7: Show,, %ScriptName% %ScriptVersion%
      ;    WinWaitClose
      }
    }
  }

;MSGBOX7:
;  SetTimer, MONITORING, Off
;  FileAppend, `n------------------------------------------------------------------------------`n%NotExistingFolder% nicht gefunden : %A_DDD% %A_MMM% %A_DD% %A_Hour%:%A_Min%:%A_Sec% %A_YYYY% (%NotExistFolderVar%)`n------------------------------------------------------------------------------`n, %rcm_LD%
;  Menu, Tray, Tip, %ScriptName%`nDer %NotExistingFolder% ist nicht vorhanden.`nEs erfolgt keine Datensicherung.
;  If rcm_Standby AND NotExistFolderVar
;    {
;    TrayTip, %ScriptName%, Der %NotExistingFolder% wurde nicht gefunden.`nDer Standby-Modus wird aktiviert.,, 17
;    Settimer, REMOVETRAYTIP, -3000
;    GoSub, PROCESSCLOSE
;    SetTimer, STICKMODE, %rcm_Timer%
;    }
;  Else
;    {
;    If !NotExistFolderVar ; wenn Variable völlig leer ist, d.h. überhaupt kein Pfad vorhanden ist
;      {
;      MsgBox, 292, %ScriptName% %ScriptVersion%, Der %NotExistingFolder% wurde nicht gefunden.`nMöchten Sie einen neuen Ordner angeben?`n`n«Nein» beendet %ScriptName%.
;      IfMsgBox, Yes
;        {
;        If !rcm_Src   ; i.e. it's blank
;          {
;          rcm_Src = %A_MyDocuments%
;          IniWrite, %rcm_Src%, %ScriptNoExt%.ini, Ordner, Quelle
;          ; MsgBox, 64, %ScriptName% %ScriptVersion%, Standard-Quellordner eingetragen., 3
;          }
;        GoSub, OPTIONEN
;        GuiControl, 4: Focus, % NotExistingFolder = "Zielordner" ? "Ziel" : "Quelle"
;        }
;      Else IfMsgBox, No
;        ExitApp
;      }
;    Else
;      {
;      rcm_Text =
;        (LTrim
;        Der %NotExistingFolder% wurde nicht gefunden.
;        (%NotExistFolderVar%)
;        Möchten Sie einen neuen Ordner angeben?
;
;        Alternativ können Sie das Programm in den Standby-
;        Modus für mobile Datenträger versetzen oder beenden.
;        Unter «Einstellungen | Optionen» können Sie einstellen,
;        dass der Standby-Modus automatisch aktiviert wird.
;        )
;      Gui, 7: Destroy
;      Gui, 7: +LastFound -MinimizeBox -MaximizeBox ; +AlwaysOnTop
;      Gui, 7: Font, s9 norm, MS Sans Serif
;      Gui, 7: Margin, 15, 10
;      Gui, 7: Add, Text, y15, %rcm_Text%
;      Gui, 7: Add, Button, y+15 w80 , &Ja
;      Gui, 7: Add, Button, Default x+5 yp w80 , &Standby
;      Gui, 7: Add, Button, x+5 yp w80 , &Beenden
;      SoundPlay, *-1
;      Gui, 7: Show,, %ScriptName% %ScriptVersion%
;      ;    WinWaitClose
;      }
;    }
;Return
;
7GUICLOSE:
7GUIESCAPE:
  Gui, 7: Destroy
  SetTimer, MONITORING, %rcm_Timer%
Return

7BUTTONJa:
  Gui, 7: Destroy
  GoSub, OPTIONEN
  GuiControl, 4: Focus, % NotExistingFolder = "Zielordner" ? "Ziel" : "Quelle"
Return

7BUTTONStandby:
  Gui, 7: Destroy
  GoSub, PROCESSCLOSE
  SetTimer, STICKMODE, %rcm_Timer%
Return

7ButtonBeenden:
  Gui, 7: Destroy
  ExitApp
Return
;------------------------------------------------------------------------------

;HELPFILE:
;  IfWinExist, %ScriptName% Hilfe ahk_class HH Parent
;    {
;      IfWinActive
;          Return
;      Else
;          WinActivate
;    }
;  Else
;    {
;      Run, %A_ScriptDir%\%ScriptNoExt%.chm,, UseErrorLevel
;      If ErrorLevel = Error
;          MsgBox, 16, %ScriptName% %ScriptVersion%, Die Hilfedatei «%ScriptNoExt%.chm» wurde nicht gefunden!`n`nDie Dateien «%ScriptNoExt%.chm» und «%ScriptNoExt%.exe»`nmüssen sich im selben Ordner befinden.`n
;    }
;Return
;------------------------------------------------------------------------------

;F9::
;  Suspend, Permit  ; exempt current subroutine from suspension
ENDABFRAGE:
  MsgBox, 36, %ScriptName% %ScriptVersion%, Möchten Sie die Datensicherung abbrechen`nund Robocopy/%ScriptName% beenden.
  IfMsgBox, Yes
    {
      Process, Exist, %rc_PID% ; Sets ErrorLevel to PID, otherwise 0
      If ErrorLevel = 0
          TrayTip, %ScriptName%, %ScriptName% wird beendet.,, 17
      ExitApp
    }
Return
;------------------------------------------------------------------------------

REMOVETRAYTIP:
  SetTimer, REMOVETRAYTIP, Off
  TrayTip
Return

SCRIPTRELOAD:
  ;  SetTimer, MONITORING, Off
  GoSub, PROCESSCLOSE
  Sleep, 500 ; sieht sonst blöd aus, 2 widersprüchlich Meldungen gleichzeitig
  Gosub, ROBOCOPYSTART ; :  Reload
Return

SCRIPTEXIT: ; wird bei OnExit ausgeführt
  Critical
  SetTimer, MONITORING, Off
  GoSub, PROCESSCLOSE
; Sleep, 2000
  ExitApp
  TrayTip
; Sleep, 2000
Return

PROCESSCLOSE:
  Critical ; andernfalls erscheint ztw. MsgBox "Robocopy wurde beendet.
  If (rc_PID) ; andernfalls bricht das Programm beim ersten Start ab.
    {
      Process, Exist, %rc_PID% ; Sets ErrorLevel to PID, otherwise 0
      If (ErrorLevel)
        {
          Process, Close, %ErrorLevel%
          Process, WaitClose, %ErrorLevel%
          FileAppend, `n------------------------------------------------------------------------------`n%A_Space% %A_Space% %A_Space% %A_Space% %A_Space% %A_Space% Terminated : %A_DDD% %A_MMM% %A_DD% %A_Hour%:%A_Min%:%A_Sec% %A_YYYY% (PID %rc_PID%)`n------------------------------------------------------------------------------`n, %rcm_LD%
          If !rcm_Standby ; andernfalls erscheint Standby-TrayTip
            {
              TrayTip, %ScriptName%, Robocopy beendet (PID %rc_PID%).,, 17
              Settimer, REMOVETRAYTIP, -2000
            }
          Suspend, On
          GoSub, TRAYRENAME ; Menu, Tray, Rename, Anhalten, Fortsetzen
        }
      IfWinExist, ahk_id %OptiGUIID%
          GuiControl, 4: Hide, StatusInfo
    }
Return


;===============================================================================
LOGVIEW:
  ; ------------------------------------------------------------------------------
  ; Systemeinstellungen
  ; ------------------------------------------------------------------------------
  ;SysGet, HSB, 3                   ; Höhe einer horizontalen Scrollleiste
  ; ------------------------------------------------------------------------------
  ; Windows Konstanten
  ; http://msdn.microsoft.com/en-us/library/bb773173(VS.85).aspx
  ; http://msdn.microsoft.com/en-us/library/ms632586(VS.85).aspx
  ; ------------------------------------------------------------------------------
  ; Edit Messages
  EM_GETSEL := 0xB0
  EM_SETSEL := 0xB1
  EM_GETRECT := 0xB2
  EM_SETRECT := 0xB4
  EM_SCROLL := 0xB5
  EM_CHARFROMPOS := 0xD7
  EM_LINESCROLL := 0xB6
  EM_SCROLLCARET := 0xB7
  EM_GETMODIFY := 0xB8
  EM_SETMODIFY := 0xB9
  EM_GETLINECOUNT := 0xBA
  EM_LINEINDEX := 0xBB
  EM_LINELENGTH := 0xC1
  EM_REPLACESEL := 0xC2
  EM_GETLINE := 0xC4
  EM_CANUNDO := 0xC6
  EM_UNDO := 0xC7
  EM_LINEFROMCHAR := 0xC9
  EM_GETFIRSTVISIBLELINE := 0xCE
  EM_POSFROMCHAR := 0xD6
  EM_CHARFROMPOS := 0xD7
  ; Edit Styles ------------------------------------------------------------------
  ES_AUTOVSCROLL := 0x40
  ES_NOHIDESEL := 0x100
  ; Window Messages --------------------------------------------------------------
  WM_SETREDRAW := 0x0B
  WM_SETTEXT := 0x0C
  WM_GETTEXT := 0x0D
  WM_GETTEXTLENGTH := 0x0E
  WM_SETCURSOR := 0x20
;  WM_NCHITTEST := 0x84
  WM_COMMAND := 0x111
  WM_VSCROLL := 0x115
;  WM_CTLCOLORLISTBOX := 0x134
  WM_MOUSEMOVE := 0x200
  WM_LBUTTONDOWN := 0x201
  WM_LBUTTONUP := 0x202
  WM_LBUTTONDBLCLK := 0x203
  WM_RBUTTONUP := 0x205
  WM_CUT := 0x300
  WM_COPY := 0x301
  WM_PASTE := 0x302
  WM_CLEAR := 0x303
  WM_UNDO := 0x304
;  WM_CTLCOLORLISTBOX := 0x134
  ; Window Styles ----------------------------------------------------------------
  WS_TABSTOP := 0x10000
  WS_DLGFRAME := 0x400000
  WS_BORDER := 0x800000
  WS_CAPTION := 0xC00000
  WS_VISIBLE := 0x10000000
  ; Window Extended Styles -------------------------------------------------------
  WS_EX_DLGMODALFRAME := 0x01
  WS_EX_CLIENTEDGE := 0x200
  WS_EX_RIGHT := 0x1000
  ; GetSysColor ------------------------------------------------------------------
  COLOR_WINDOW := 5                   ; Normaler Fensterhintergrund
  COLOR_3DFACE := 15                  ; Hintergrund für DialogBoxen (AHK)
  ; Maus -------------------------------------------------------------------------
  MK_LBUTTON := 0x1
  ; ------------------------------------------------------------------------------
  ; Konstanten
  ; ------------------------------------------------------------------------------
  WinTitel := ScriptName " " ScriptVersion
  ; ------------------------------------------------------------------------------
  ; Variablen
  ; ------------------------------------------------------------------------------
  ; Schriftattribute
  SchriftAttr := "s10"
  ; SchriftName
  SchriftName := "Courier New"
  ; Eingelesene Datei
  GewählteDatei := ""
  ; Aktuelle letzte Zeilenummer
  MaxZeile := 1
  ; Das Edit wurde verändert
  EditGeändert := False
  ; Suchtext
  SucheNach := ""
  ; Weitersuchen ist aktiviert
  WeiterSuchen := False
  ; Aktuelle Zeichenzahl im Edit
  ZeichenZahl := 0
  ; Aktuelle Zeilenzahl im Edit
  ZeilenDiff := 0
  ; Beginn der aktuellen Auswahl
  StartPos := 0
  ; Ende der aktuellen Auswahl
  EndePos := 0
  ; Verzögerung für den Aufruf von EDITAKTIONEN in ms,
  ; auf langsamen Rechnern kann ein höherer Wert erforderlich sein, wenn nach
  ; dem Einlesen von Dateien nicht alles korrekt positioniert wird.
  Verzögerung := 2
  ; Aktion wurde abgebrochen
  Abbruch := False
  ; Zeilennummern anzeige?
  ZeilenNummern := False
  ; ------------------------------------------------------------------------------
  ; Farbe für Gui und Controls bestimmen
  ; ------------------------------------------------------------------------------
  ; COLOR_3DFACE ist (auch) die Hintergrundfarbe für Dialogboxen. AHK verwendet
  ; diese Farbe für den Guihintergrund und den Hintergrund einiger Feldtypen
  ; wie z.B. Textfelder.
  ; Die Farbe kommt als BGR-Wert und muss nach RGB konvertiert werden.
  BGR := DLLCall("GetSysColor", "Int", COLOR_3DFACE)
  SetFormat, Integer, H
  GuiColor := ((BGR & 0xFF) << 16) + (BGR & 0xFF00) + ((BGR & 0xFF0000) >> 16)
  SetFormat, Integer, D
  ; ------------------------------------------------------------------------------
  ; Gui
  ; ------------------------------------------------------------------------------
  Gui, Destroy
  GuiW := 0
  GuiH := 0
  ; Menü Datei -------------------------------------------------------------------
  FMMENU := "Datei"
  FMNAME := "&Datei"
  FMAKTUELL := "&Aktualisieren`tF5"
  FMSAVA := "Speichern &unter...`tF12"
  FMEXIT := "&Schließen`tEsc"

  Menu, %FMMENU%, Add
  Menu, %FMMENU%, Delete

  Menu, %FMMENU%, Add, %FMAKTUELL%, LOGLESEN
  Menu, %FMMENU%, Add
  Menu, %FMMENU%, Add, %FMSAVA%, DATEISPEICHERNUNTER
  ; Menu, %FMMENU%, Disable, %FMSAVA%
  Menu, %FMMENU%, Add
  Menu, %FMMENU%, Add, %FMEXIT%, GuiClose
  Menu, %FMMENU%, Color, %GuiColor%
  ; Menü Bearbeiten --------------------------------------------------------------
  BMMENU := "Bearbeiten"
  BMNAME := "&Bearbeiten"
  BMUNDO := "&Rückgängig`tStrg+Z"
  BMCUT := "A&usschneiden`tStrg+X"
  BMCOPY := "&Kopieren`tStrg+C"
  BMPASTE := "&Einfügen`tStrg+V"
  BMCLEAR := "&Löschen`tEntf"
  BMALL := "&Alles auswählen`tStrg+A"

  Menu, %BMMENU%, Add
  Menu, %BMMENU%, Delete

  Menu, %BMMENU%, Add, %BMUNDO%, MENÜBEARBEITEN
  Menu, %BMMENU%, Add
  Menu, %BMMENU%, Add, %BMCUT%, MENÜBEARBEITEN
  Menu, %BMMENU%, Add, %BMCOPY%, MENÜBEARBEITEN
  Menu, %BMMENU%, Add, %BMPASTE%, MENÜBEARBEITEN
  Menu, %BMMENU%, Add, %BMCLEAR%, MENÜBEARBEITEN
  Menu, %BMMENU%, Add
  Menu, %BMMENU%, Add, %BMALL%, MENÜBEARBEITEN
  Menu, %BMMENU%, Color, %GuiColor%
  ; Menü Suchen ------------------------------------------------------------------
  SMMENU := "Suchen"
  SMNAME := "&Suchen"
  SMFIND := "&Suchen`tStrg+F"
  SMNEXT := "&Weitersuchen`tF3"

  Menu, %SMMENU%, Add
  Menu, %SMMENU%, Delete

  Menu, %SMMENU%, Add, %SMFIND%, SUCHENGUI ; MENÜSUCHEN
  Menu, %SMMENU%, Add, %SMNEXT%, WEITERSUCHEN
  Menu, %SMMENU%, Color, %GuiColor%
  ; Menü Tools -------------------------------------------------------------------
  XMMENU := "Programm"
  XMNAME := "&Programm"
  XMHILFE := "&Hilfe`tF1"
  XMOPTIONEN := "&Einstellungen`tF2"
  XMABOUT := "&Info`tF4"

  Menu, %XMMENU%, Add
  Menu, %XMMENU%, Delete

  Menu, %XMMENU%, Add, %XMHILFE%, HELPGUI
  Menu, %XMMENU%, Add, %XMOPTIONEN%, OPTIONEN
  Menu, %XMMENU%, Add
  Menu, %XMMENU%, Add, %XMABOUT%, ABOUT
  Menu, %XMMENU%, Color, %GuiColor%
  ; Guimenü ----------------------------------------------------------------------
  Menu, GuiMenu, Add, %FMNAME%, :%FMMENU%
  Menu, GuiMenu, Add, %BMNAME%, :%BMMENU%
  Menu, GuiMenu, Add, %SMNAME%, :%SMMENU%
  Menu, GuiMenu, Add, %XMNAME%, :%XMMENU%
  Menu, GuiMenu, Color, %GuiColor%
  Gui, +Resize +MinSize
  Gui, Color, %GuiColor%, %GuiColor%
  Gui, Margin, 0, 0
  Gui, Menu, GuiMenu
  Gui, Font, %SchriftAttr%, %SchriftName%
  EDTXH := 650 ; + 1 + HSB
  ; Für die Anfangsbreite des Edits wird eine Zeile mit 81 Zeichen erstellt
  EDTX := ""
  Loop, 81 {
      EDTX .= "+"
    }
  ; Das Edit wird mit folgenden Eigenschaften erstellt:
  ; x+0          Das Edit schließt nahtlos an die ListBox an
  ; ym           Das Edit ist zum Nummernedit um 3 Pixel nach oben verschoben
  ; -BackGround  Die voreingestellte Hintergrundfarbe wird nicht verwendet
  ; ES_NOHIDESEL Die aktuelle Selektion geht bei Fokusverlust nicht verloren
  ; T12          Tabulatoren alle 12 Dialogeinheiten, das bringt für den oben
  ;              eingestellten Font einen Abstand von 3 Zeichen. Für andere Fonts
  ;              oder Schriftgrößen muss man rumprobieren.
  ; WantTab      Das Edit wertet die Tab-Taste aus
  CtrlOptions := "x+2 h" EDTXH " -BackGround " ES_NOHIDESEL . " T12 -HScroll WantTab vEDTX HwndEDTXID"
  Gui, Add, Edit, %CtrlOptions%, %EDTX%
  GuiControl, , EDTX
  EDTX := ""
; EM_SETMARGINS = 0xD3; EC_LEFTMARGIN = 0x1; EC_RIGHTMARGIN = 0x2
; wParam = the margins to be set
; lParam = The low-order word specifies the new width of the left margin, in pixels.
; Long = 65536
; lLongValue := Long + 2 ; 1 scheint schon ohnehin als Margin vorhanden zu sein.
; PostMessage, 0xD3, 0x1, % lLongValue, Edit1, ahk_id %EDTXID%
  PostMessage, 0xD3, 0x1, 65540,, ahk_id %EDTXID%
  ;MsgBox % errorlevel ; returns 0
  GuiControlGet, EDTX, Pos
  Gui, Font
  ; Navigationsbuttons
  Gui, Add, Button, x%EDTXX% y+2 h25 w110 vEZEILE HwndEZEILEID gGEHEZU 0x8000, &Anfang
  GuiControlGet, EZEILE, Pos
  Gui, Add, Button, x+0 yp hp w110 vLZEILE HwndLZEILEID gGEHEZU 0x8000, E&nde
  GuiControlGet, LZEILE, Pos
  Gui, Add, Button, x+0 yp hp w110 vHILFE HwndHILFE gHELPGUI 0x8000, &Hilfe...
  GuiControlGet, HILFE, Pos
  Gui, Add, Button, x+0 yp hp w110 vEINSTELL HwndEINSTELL gOPTIONEN 0x8000, &Einstellungen...
  GuiControlGet, EINSTELL, Pos
  Gui, Add, Button, x+0 yp hp w110 vAKTUELL HwndAKTUELL gLOGLESEN 0x8000, A&ktualisieren
  GuiControlGet, AKTUELL, Pos
  Gui, Add, Button, x+0 yp hp w110 vSCHLIESSEN HwndSCHLIESSEN gGuiClose 0x8000, S&chließen
  GuiControlGet, SCHLIESSEN, Pos
  Gui, Add, StatusBar
  SB_SetParts(120, 120)  ; Create three parts in the bar (the third part fills all the remaining width).
  Gui, +LastFound
  LogGuiID := WinExist()
  GroupAdd, LogGUI, ahk_id %LogGuiID%
  Gui, Show, h700, %WinTitel%
  GuiControl, Focus, EDTX
  EditGeändert := False
  GoSub, LOGLESEN
Return
; ------------------------------------------------------------------------------
; Controls bei Größenänderung neu positionieren
; ------------------------------------------------------------------------------
GuiSize:
  If (A_EventInfo = 1)
    {
      Return
    }
  If (GuiW = 0)
    {
      GuiW := A_GuiWidth
      GuiH := A_GuiHeight
      Return
    }
  DW := A_GuiWidth - GuiW
  DH := A_GuiHeight - GuiH
  GuiControl, Move, EDTX, % "w" (EDTXW += DW) " h" (EDTXH += DH)
  GuiControl, MoveDraw, EZEILE, % "y" (EZEILEY += DH) "w" (EZEILEW += DW/6)
  GuiControl, MoveDraw, LZEILE, % "x" (LZEILEX += 1*DW/6) "y" (LZEILEY += DH) "w" (LZEILEW += DW/6)
  GuiControl, MoveDraw, HILFE, % "x" (HILFEX += 2*DW/6) "y" (HILFEY += DH) "w" (HILFEW += DW/6)
  GuiControl, MoveDraw, EINSTELL, % "x" (EINSTELLX += 3*DW/6) "y" (EINSTELLY += DH) "w" (EINSTELLW += DW/6)
  GuiControl, MoveDraw, AKTUELL, % "x" (AKTUELLX += 4*DW/6) "y" (AKTUELLY += DH) "w" (AKTUELLW += DW/6)
  GuiControl, MoveDraw, SCHLIESSEN, % "x" (SCHLIESSENX += 5*DW/6) "y" (SCHLIESSENY += DH) "w" (SCHLIESSENW += DW/6)
  GuiW := A_GuiWidth
  GuiH := A_GuiHeight
Return
; ------------------------------------------------------------------------------
; Programm beenden
; ------------------------------------------------------------------------------
GuiClose:
GuiEscape:
  SendMessage, EM_GETMODIFY, 0, 0, , ahk_id %EDTXID%
  If (ErrorLevel) {
      MsgBox, 8227, %WinTitel%
              , % "Möchten Sie die Änderungen speichern?"
      IfMsgBox, Cancel
          Return
      IfMsgBox, Yes
          GoSub, DATEISPEICHERNUNTER
    }
  Gui, Destroy ; ExitApp
Return
; ------------------------------------------------------------------------------
; Hilfsguis schließen
; ------------------------------------------------------------------------------
GuiXClose:
GuiXEscape:
  Gui, 1:-Disabled
  Gui, Destroy
  Abbruch := True
Return
; ------------------------------------------------------------------------------
LOGLESEN:
  SendMessage, EM_GETMODIFY, 0, 0, , ahk_id %EDTXID%
  If (ErrorLevel) {
      MsgBox, 8227, %WinTitel%
              , % "Möchten Sie die Änderungen speichern?"
      IfMsgBox, Cancel
          Return
      IfMsgBox, Yes
          GoSub, DATEISPEICHERNUNTER
    }
  GewählteDatei := rcm_LD
  FileRead, DateiInhalt, %GewählteDatei%
  GoSub, NEUERINHALT
  Gui, Default ; LogSize wird sonst nicht über F5 aktualisiert
  FileGetSize, LogSize, %rcm_LD%
  LogSize := LogSize / 1024
  If LogSize > 1000
      LogSize := LogSize > 1000000 ? (Round(LogSize / 1024, 0) . " MB") : (Round(LogSize / 1024, 1) . " MB")
  Else
      LogSize := LogSize > 100 ? Round(LogSize, 0) . " KB" : Round(LogSize, 1) . " KB"
  Process, Exist, %rc_PID% ; robocopy.exe
  If ErrorLevel = 0
      SB_SetText("Robocopy beendet", 1)
  Else
      SB_SetText("Robocopy PID " . rc_PID, 1)
  SB_SetText("Logdatei " . LogSize, 2)
  SB_SetText(rcm_LD, 3)
Return
; ------------------------------------------------------------------------------
DATEILESEN:
  If (EditGeändert) {
      MsgBox, 8227, %WinTitel%
              , % "Möchten Sie die Änderungen speichern?"
      IfMsgBox, Cancel
          Return
      IfMsgBox, Yes
          GoSub, DATEISPEICHERNUNTER
    }
  If (LetzteDatei) {
      DateiPfad := LetzteDatei
      LetzteDatei := ""
  } Else {
      DateiPfad := ""
      FileSelectFile, DateiPfad, 35
              , %A_ScriptDir%\*.log, Datei öffnen:, Logdateien (*.log)
      If (!DateiPfad) {
          Return
        }
    }
  GewählteDatei := DateiPfad
  FileRead, DateiInhalt, %GewählteDatei%
  GoSub, NEUERINHALT
Return
; ------------------------------------------------------------------------------
; Edit hat neuen Inhalt
; ------------------------------------------------------------------------------
NEUERINHALT:
  Sleep, %Verzögerung%
  If A_IsUnicode ; AHK_L
    GuiControl, , EDTX, %DateiInhalt% ; % Oem2Ansi(DateiInhalt) ; Vista-Patch
  Else
    GuiControl, , EDTX, % Oem2Ansi(DateiInhalt) ; Vista-Patch
  ; Textlänge im Edit abfragen
  SendMessage, WM_GETTEXTLENGTH, 0, 0, , ahk_id %EDTXID%
  ZeichenZahl := ErrorLevel
  ; Schreibmarke ans Ende setzen
  SendMessage, EM_SETSEL, ZeichenZahl, ZeichenZahl, , ahk_id %EDTXID%
  ; Zur Zeile mit der Schreibmarke scrollen
  SendMessage, EM_SCROLLCARET, 0, 0, , ahk_id %EDTXID%
  ; Edit als nicht verändert kennzeichnen
  SendMessage, EM_SETMODIFY, 0, 0, , ahk_id %EDTXID%
  EditGeändert := False
  ;  Menu, %FMMENU%, Enable, %FMSAVA%
  Gui, +LastFound
  GuiControl, Focus, EDTX
Return

; ------------------------------------------------------------------------------
; Datei speichern unter
; ------------------------------------------------------------------------------
DATEISPEICHERNUNTER:
  Gui, +OwnDialogs
  Gui, Submit, NoHide
  If (!EDTX) {
      Return
    }
  If (GewählteDatei) {
      SplitPath, GewählteDatei,  , Verzeichnis
  } Else {
      Verzeichnis := A_ScriptDir
    }
  FileSelectFile, DateiPfad, S24, %Verzeichnis%, Datei speichern unter ...
          , Skripte (*.log)
  If (ErrorLevel) {
      Return
    }
  FileDelete, %DateiPfad%_Neu
  FileAppend, %EDTX%, %DateiPfad%_Neu
  FileMove, %DateiPfad%_Neu, %DateiPfad%, 1
  If (ErrorLevel) {
      MsgBox, 8208, %WinTitel%, Fehler beim Speichern der Datei`n%DateiPfad%
      Return
    }
  GewählteDatei := DateiPfad
  GoSub, EDITGESPEICHERT
Return
; ------------------------------------------------------------------------------
; Edit wurde gespeichert
; ------------------------------------------------------------------------------
EDITGESPEICHERT:
  Sleep, %Verzögerung%
  SendMessage, EM_SETMODIFY, 0, 0, , ahk_id %EDTXID%
  EditGeändert := False
  ;  Menu, %FMMENU%, Disable, %FMSAVA%
  Gui, +LastFound
  GuiControl, Focus, EDTX
  Sleep, %Verzögerung%
Return
; ------------------------------------------------------------------------------
; Menü Bearbeiten
; ------------------------------------------------------------------------------
MENÜBEARBEITEN:
  If (A_ThisMenuItem = BMUNDO)
      SendMessage, WM_UNDO, 0, 0, , ahk_id %EDTXID%
  Else If (A_ThisMenuItem = BMCUT)
      SendMessage, WM_CUT, 0, 0, , ahk_id %EDTXID%
  Else If (A_ThisMenuItem = BMCOPY)
      SendMessage, WM_COPY, 0, 0, , ahk_id %EDTXID%
  Else If (A_ThisMenuItem = BMPASTE)
      SendMessage, WM_PASTE, 0, 0, , ahk_id %EDTXID%
  Else If (A_ThisMenuItem = BMCLEAR)
      SendMessage, WM_CLEAR, 0, 0, , ahk_id %EDTXID%
  Else If (A_ThisMenuItem = BMALL)
      SendMessage, EM_SETSEL, 0, -1, , ahk_id %EDTXID%
Return
; ------------------------------------------------------------------------------
; Suchen|Ersetzen: GUI
; ------------------------------------------------------------------------------
SUCHENGUI:
  FeldDimensionen("Text", W, H)
  SendMessage, EM_GETSEL, &StartPos, &EndePos, , ahk_id %EDTXID%
  StartPos := NumGet(StartPos)
  EndePos := NumGet(EndePos)
  Gui, 10: Default
  Gui, +Owner1 +LabelGuiX +AlwaysOnTop -MinimizeBox -MaximizeBox ; +ToolWindow
  Gui, Margin, 10, 10
  Gui, Add, Text, h%H% 0x200 vSUTX, Suchtext:
  GuiControlGet, SUTX, Pos
  L := StrLen(MaxZeile)
  Gui, Add, Edit, ym w250 hp vSUEDSE, %SucheNach%
  GuiControlGet, SUEDSE, Pos
  Gui, Add, GroupBox, xm r3 Section vSUGBO, Optionen
  GuiControlGet, SUGBO, Pos
  Gui, Add, Checkbox, xp+10 yp+25 vSUCBK, Groß-/&Kleinschreibung
  GuiControlGet, SUCBK, Pos
  GuiControl, , SUCBK, % (SUCBK = 1)
  Gui, Add, Checkbox, xp y+5 vSUCBW, Nur ganzes &Wort
  GuiControlGet, SUCBW, Pos
  GuiControl, , SUCBW, % (SUCBW = 1)
  SUGBOW := (SUCBKW > SUCBWW ? SUCBKW : SUCBWW)
  SUGBOW += 20
  GuiControl, Move, SUGBO, w%SUGBOW%
  X := SUGBOX + SUGBOW + 10
  Gui, Add, GroupBox, x%X% ys r3 vSUGBR, Richtung
  GuiControlGet, SUGBR, Pos
  Gui, Add, Radio, xp+10 yp+25 vSURBV, &Vorwärts
  GuiControlGet, SURBV, Pos
  If (SURBV = "") {
      SURBV := 1
    }
  GuiControl, , SURBV, % (SURBV = 1)
  Gui, Add, Radio, xp y+5 vSURBR, &Rückwärts
  GuiControlGet, SURBR, Pos
  GuiControl, , SURBR, % (SURBR = 1)
  Gui, Add, Radio, xp y+5 vSURBG, &Gesamt
  GuiControlGet, SURBG, Pos
  GuiControl, , SURBG, % (SURBG = 1)
  SUGBRW := SURBVW
  If (SURBRW > SUGBRW) {
      SUGBRW := SURBRW
    }
  If (SURBGW > SUGBRW) {
      SUGBRW := SURBGW
    }
  SUGBRW += 20
  GuiControl, Move, SUGBR, w%SUGBRW%
  X := SUGBRX + SUGBRW + 10
  Gui, Add, GroupBox, x%X% ys r3 vSUGBB, Bereich
  GuiControlGet, SUGBB, Pos
  Gui, Add, Radio, xp+10 yp+25 vSURBD gSUGRBB Checked Disabled, Ganze &Datei
  GuiControlGet, SURBD, Pos
  Gui, Add, Radio, xp y+5 vSURBA gSUGRBB Disabled, In &Auswahl
  GuiControlGet, SURBA, Pos
  If (StartPos != EndePos) {
      GuiControl, Enable, SURBD
      GuiControl, Enable, SURBA
      GuiControl, , SURBA, 1
      GuiControl, , SURBV, 1
      GuiControl, Disable, SURBG
    }
  SUGBBW := SURBDW
  If (SURBAW > SUGBBW) {
      SUGBBW := SURBAW
    }
  SUGBBW += 20
  GuiControl, Move, SUGBB, w%SUGBBW%
  SUEDSEW := SUGBBX + SUGBBW - SUEDSEX
  GuiControl, Move, SUEDSE, w%SUEDSEW%
  GuiControl, Move, SUEDRP, w%SUEDSEW%
  W := SUEDSEW // 3
  Gui, Add, Button, xm w%W% h%H% gSUCHENERSETZEN Default
          , % (Ersetzen ? "Ersetzen" : "Suchen")
  X := (SUEDSEW + SUEDSEX - W)
  Gui, Add, Button, x%X% yp wp hp gGuiXClose, &Abbrechen
  Gui, Show, AutoSize, Suchen ; % (Ersetzen ? "   Ersetzen" : "   Suchen")
Return
; Kontrolle der Radios für die Bereichsauswahl
SUGRBB:
  Gui, Submit, NoHide
  If (SURBA) {
      GuiControl, , SURBV, 1
      GuiControl, Disable, SURBG
  } Else {
      GuiControl, Enable, SURBG
    }
Return
; ------------------------------------------------------------------------------
; Suchen/Ersetzen
; ------------------------------------------------------------------------------
SUCHENERSETZEN:
  Aktion := A_GuiControl
  Gui, Submit
  SucheNach := SUEDSE
  ;  ErsetzeDurch := SUEDRP
  Position := 0
  If (SURBG)
      Direction := 0
  If (SURBV)
      Direction := 1
  If (SURBR)
      Direction := 2
  Gui, Destroy
  If (!SucheNach) {
      Return
    }
  Gui, 1:Default
  ControlGetText, EDTX, , ahk_id %EDTXID%
  If (Aktion = "Suchen") {
      GoSub SUCHESTARTEN
    }
Return
; ------------------------------------------------------------------------------
; Suche starten
; ------------------------------------------------------------------------------
SUCHESTARTEN:
  Sleep, %Verzögerung%
  If StrInStr(EDTX, SUEDSE, Position, Direction, SUCBK, SUCBW
            , SURBA, StartPos, EndePos) {
    ; Treffer auswählen
      SendMessage, EM_SETSEL, Position - 1, Position - 1 + StrLen(SUEDSE)
          , , ahk_id %EDTXID%
  ; Weitersuchen freigeben
  WeiterSuchen := True
  ; Zur aktuellen Zeile scrollen
  GoSub, AZEILE
} Else {
    Gui, +OwnDialogs
    MsgBox, 8256, % "   Suchen"
            , Der Suchvorgang ist abgeschlossen.
    SendMessage, EM_SETSEL, StartPos, EndePos, , ahk_id %EDTXID%
    WeiterSuchen := False
    GuiControl, Focus, EDTX
  }
Return
; ------------------------------------------------------------------------------
; Nächsten Treffer suchen
; ------------------------------------------------------------------------------
WEITERSUCHEN:
  If (!WeiterSuchen) {
      Return
    }
  Sleep, %Verzögerung%
  If StrInStr(EDTX, SUEDSE, Position, Direction, SUCBK, SUCBW
            , SURBA, StartPos, EndePos) {
      SendMessage, EM_SETSEL, Position -1, Position - 1 + StrLen(SUEDSE)
          , , ahk_id %EDTXID%
  GoSub, AZEILE
} Else {
    Gui, +OwnDialogs
    MsgBox, 8256, % "   Suchen"
            , Der Suchvorgang ist abgeschlossen.
    WeiterSuchen := False
    SendMessage, EM_SETSEL, StartPos, EndePos, , ahk_id %EDTXID%
    GuiControl, Focus, EDTX
  }
Return
; ------------------------------------------------------------------------------
; Menü Tools auswerten
; ------------------------------------------------------------------------------
TOOLMENÜ:
  Gosub, OPTIONEN
Return
; ------------------------------------------------------------------------------
; Gehe zu Zeile
; ------------------------------------------------------------------------------
GEHEZU:
  If (A_GuiControl = "GEHEZU") {
      GuiControlGet, EDGO
  } Else If (A_GuiControl = "EZEILE") {
      EDGO := 1
  } Else If (A_GuiControl = "LZEILE") {
      SendMessage, EM_GETLINECOUNT, 0, 0, , ahk_id %EDTXID%
      EDGO := ErrorLevel
    }
  If (!EDGO) {
      GuiControl, Focus, EDTX
      Return
    }
  SendMessage, EM_LINEINDEX, EDGO - 1, 0, , ahk_id %EDTXID%
  If (ErrorLevel > 0x7FFFFFFF) {   ; -1
      GuiControl, Focus, EDTX
      Return
    }
  GeheZuPos := ErrorLevel
  SendMessage, EM_SETSEL, GeheZuPos, GeheZuPos, , ahk_id %EDTXID%
  GoSub, AZEILE
Return
; ------------------------------------------------------------------------------
; Zur aktuellen Zeile scrollen
; ------------------------------------------------------------------------------
AZEILE: ; wird benötigt
  SendMessage, EM_SCROLLCARET, 0, 0, , ahk_id %EDTXID%
  SendMessage, EM_LINEFROMCHAR, -1, 0, , ahk_id %EDTXID%
  ZeilenDiff := ErrorLevel
  SendMessage, EM_GETFIRSTVISIBLELINE, 0, 0, , ahk_id %EDTXID%
  ZeilenDiff -= (ErrorLevel + 4)
  SendMessage, EM_LINESCROLL, 0, ZeilenDiff, , ahk_id %EDTXID%
  GuiControl, Focus, EDTX
Return
; _____________________________________________________________________________
; ——————————————————————————————————————————————————————————————————————————————
; ||  I N F O  //
; ——————————————
; ¯¯¯¯¯¯¯¯¯¯¯¯¯
ABOUT:
  Gui, 6: Destroy
  Gui, 6: +LastFound -Caption +Border +AlwaysOnTop
  Gui6ID := WinExist()
; Gui, 6: +Owner1 ; Make Gui #1 the owner Gui #2; muss in einer eigenen Zeile stehen
  Gui, 6: Font, s9 norm, MS Sans Serif
  Gui, 6: Color, c%SplashColor%
  Gui, 6: Margin, 10, 10
  Gui, 6: Add, Text,, %ScriptName% %A_Space% Ver. %ScriptVersion%.%ScriptBuild% (%ScriptDate%)
  Gui, 6: Add, Text,, Copyright (C) 2007-2010%A_Space% Dr. Wilhelm Happe
  Gui, 6: Add, Text,, %ScriptName% darf generell ohne Einschränkungen genutzt werden.`nAllerdings ist es nicht gestattet %ScriptName% in unveränderter oder`nmodifizierter Form kommerziell zu verwerten.`nEine Weitergabe von %ScriptName% ist erlaubt, so lange nicht der`nCopyright-Vermerk entfernt oder verändert wird.
  Gui, 6: Font, underline
  Gui, 6: Add, Text, cNavy gHOMEPAGE vHomePage, %HomePage%
  Gui, 6: Show,, Über %ScriptName%
  OnMessage(0x200, "WM_MOUSEMOVE6")
  OnMessage(0x201, "WM_LBUTTONDOWN6")
Return
;------------------------------------------------------------------
6GUICLOSE:
6GUIESCAPE:
  OnMessage(0x200, "") ; deactivate WM_MouseMove
  DllCall("DestroyCursor","Uint",hCur)
; OnMessage(0x201, "WM_LBUTTONDOWN") ; for moving the clock
  DllCall("AnimateWindow","UInt",Gui6ID,"Int",500,"UInt","0x90000")
; Gui, 1: -Disabled  ; Re-enable the main window (must be done prior to the next step).
  Gui, 6: Destroy
Return
;------------------------------------------------------------------
; ------------------------------------------------------------------------------
; Hotkeys
; ------------------------------------------------------------------------------

#IfWinActive ahk_group LogGUI
F12::
  Suspend, Permit  ; exempt current subroutine from suspension
  GoSub, DATEISPEICHERNUNTER
Return
^f::
  Suspend, Permit  ; exempt current subroutine from suspension
  GoSub, SUCHENGUI ; SUCHENPERHOTKEY
Return
F1::
  Suspend, Permit  ; exempt current subroutine from suspension
  GoSub, HELPGUI ; HELPFILE
Return
F2::
  Suspend, Permit  ; exempt current subroutine from suspension
  GoSub, OPTIONEN
F3::
  Suspend, Permit  ; exempt current subroutine from suspension
  GoSub, WEITERSUCHEN
Return
Return
F4::
  Suspend, Permit  ; exempt current subroutine from suspension
  GoSub, ABOUT
Return
F5::
  Suspend, Permit  ; exempt current subroutine from suspension
  GoSub, LOGLESEN
Return
#IfWinActive

; ------------------------------------------------------------------------------
FeldDimensionen(Text, ByRef W, ByRef H, SAttr = "", SName = "") {
    ; Höhe und Breite eines einzeiligen Edits für einen vorgegebenen Text und
    ; und ggf. Zeichensatz und Schriftattribute bestimmem
    ; Schriftattribute und Zeichensatz übernehmen
    Gui, 55:Font, %SAttr%, %SName%
    ; Edit füllen
    Gui, 55:Add, Edit, hwndHWND, %Text%
    ; Breite und Höhe holen
    ControlGetPos, , , W, H, , ahk_id %HWND%
    ; Und ab dafür!
    Gui, 55:Destroy
  }
; ------------------------------------------------------------------------------
; StrInStr()
; Funktion:
;     Nadel im Heuhaufen suchen (string in string)
; Parameter:
;     HeuHaufen      ByRef       zu durchsuchende Zeichenfolge
;     Nadel          ByRef       Suchtext
;     Position       ByRef       Trefferposition
;                                Zeichenposition mit Basis 1
;                                0 = neue Suche
;     Suchrichtung   Optional    Suchrichtung/-bereich
;                                0 = gesamt
;                                1 = vorwärts
;                                2 = rückwärts
;                                Standard: 0
;     MatchCase      Optional    Groß-/Kleinschreibung beachten
;                                0|1 = nein|ja
;                                Standard: 0
;     GanzesWort     Optional    Nur "ganzes Wort" suchen
;                                0|1 = nein|ja
;                                Standard: 0
;     Auswahl        Optional    Nur in Auswahl suchen
;                                0|1 = nein|ja
;                                Standard: 0
;     StartPos       Optional    Beginn der aktuellen Auswahl
;                                Zeichenposition mit Basis 0
;                                Standard: 0
;     EndePos        Optional    Ende der aktuellen Auswahl
;                                Zeichenposition mit Basis 0
;                                Standard: 0
;  Rückgabewerte:
;     Returncode     1 (True)  : Treffer
;                    0 (False) : Kein Treffer
;     Position       Position des ersten Trefferzeichens mit Basis 1
; ------------------------------------------------------------------------------
StrInStr(ByRef HeuHaufen         ; Worin suchen
        , ByRef Nadel             ; Was suchen
        , ByRef Position          ; 0 = ersten Treffer suchen
        , Suchrichtung = 1        ; Wie suchen
        , GroßKlein = 0           ; Groß-\Kleinschreibung beachten
        , GanzesWort = 0          ; Nur ganzes Wort suchen
        , Auswahl = 0             ; In Auswahl suchen
        , StartPos = 0            ; In Auswahl suchen: Startposition
        , EndePos = 0)            ; In Auswahl suchen: Endposition-
{
  Static Distanz                ; Distanz zum Anfang/Ende
  Static Länge                  ; Länge des "Haystacks"
  Static Richtung               ; Suchrichtung (L|R)
  ; ---------------------------------------------------------------------------
  ; Offset berechnen
  If (Position = 0) {
      ; Erste Suche
      Pos := Position
      Länge := StrLen(HeuHaufen)
      Richtung := (Suchrichtung = 2 ? "R" : "L")
      If (Suchrichtung = 1) {
          Distanz := StartPos
      } Else If (Suchrichtung = 2) {
          Distanz := Länge - EndePos - 1
      } Else {
          Distanz := 0
        }
  } Else {
      ; Weitersuchen
      Pos := Position - 1
      If (Suchrichtung = 2) {
          Distanz := Länge - Pos - 1
      } Else {
          Distanz := Pos + StrLen(Nadel)
        }
    }
  ; ---------------------------------------------------------------------------
  ; Zum ersten Mal in meiner AHK-Karriere habe ich StringGetPos verwendet,
  ; weil man damit sowohl vorwärts als auch rückwärts mit einer vorgegebenen
  ; Distanz zum Anfang bzw. Ende suchen kann
  Loop {
      StringGetPos, Pos, HeuHaufen, %Nadel%, %Richtung%, %Distanz%
      If (ErrorLevel) {
          Return False
        }
      ; ------------------------------------------------------------------------
      ; Überprüfen, ob das Ergebnis der Suche mit StringGetPos wirklich alle
      ; Bedingungen erfüllt
      ; Liegt der Treffer ggf. innerhalb der Auswahl?
      If (Auswahl) {
          If (Pos < StartPos Or Pos > (EndePos - StrLen(Nadel))) {
              Return False
            }
        }
      ; Erfüllt er ggf. die Bedingungen "ganzes Wort" / "Schreibung"
      If (GroßKlein Or GanzesWort) {
          RX1 := (GroßKlein ? "" : "i)") (GanzesWort ? "\b" : "") "\Q"
          RX2 := "\E" (GanzesWort ? "\b" : "")
          RXStart:= Pos + 1 - (GanzesWort And Pos > 0)
          RXLänge := StrLen(Nadel) + (GanzesWort * 2)
          If RegExMatch(SubStr(HeuHaufen, RXStart, RXLänge), RX1 Nadel RX2) {
              Position := Pos + 1
              Return True
            }
      } Else {
          Position := Pos + 1
          Return True
        }
      ; ------------------------------------------------------------------------
      ; Distanz für nächsten Durchlauf
      If (Richtung = "R") {
          Distanz := StrLen(HeuHaufen) - Pos - 1
      } Else {
          Distanz := Pos + StrLen(Nadel)
        }
    }
  Return False
}

Oem2Ansi(zString)
  {
  Ansi2Unicode(zString, wString, 1)
  Unicode2Ansi(wString, sString, 0)
  Return sString
  }

Ansi2Unicode(ByRef sString, ByRef wString, CP = 0)
  {
  nSize := DllCall("MultiByteToWideChar", "Uint", CP, "Uint", 0, "Uint", &sString, "int", -1, "Uint", 0, "int", 0)
  VarSetCapacity(wString, nSize * 2)
  DllCall("MultiByteToWideChar", "Uint", CP, "Uint", 0, "Uint", &sString, "int", -1, "Uint", &wString, "int", nSize)
  }

Unicode2Ansi(ByRef wString, ByRef sString, CP = 0)
  {
  nSize := DllCall("WideCharToMultiByte", "Uint", CP, "Uint", 0, "Uint", &wString, "int", -1, "Uint", 0, "int", 0, "Uint", 0, "Uint", 0)
  VarSetCapacity(sString, nSize)
  DllCall("WideCharToMultiByte", "Uint", CP, "Uint", 0, "Uint", &wString, "int", -1, "str", sString, "int", nSize, "Uint", 0, "Uint", 0)
  }

WM_MOUSEMOVE6()
  {
    global hCurs
    IfNotEqual, A_Gui, 6, Return
    MouseGetPos,,,, ctrl
    If ctrl in static4 ; Avoid spaces in list
        DllCall("SetCursor", "UInt", hCurs)
  }

WM_LBUTTONDOWN6()
  {
    IfNotEqual, A_Gui, 6, Return
    IfNotEqual, A_GuiControl, HomePage, GoSub, 6GUICLOSE
  }

WM_MOUSEMOVE3(wParam, lParam)
  {
    Global hCurs
    IfNotEqual, A_Gui, 3, Return
    MouseGetPos,,,, ctrl
    If ctrl in Static6,Static8,Static10
        DllCall("SetCursor", "UInt", hCurs)
    Return
  }
